package Injection;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

import beans.gmfmap.children;
import beans.gmfmap.childrenFeature;
import beans.gmfmap.compartment;
import beans.gmfmap.compartments;
import beans.gmfmap.containmentFeature;
import beans.gmfmap.creationConstraints;
import beans.gmfmap.diagram;
import beans.gmfmap.diagramCanvas;
import beans.gmfmap.diagramLabel;
import beans.gmfmap.diagramLink;
import beans.gmfmap.diagramNode;
import beans.gmfmap.domainInitializer;
import beans.gmfmap.domainMetaElement;
import beans.gmfmap.domainModel;
import beans.gmfmap.domainSpecialization;
import beans.gmfmap.feature;
import beans.gmfmap.gmfmap;
import beans.gmfmap.initializers;
import beans.gmfmap.labelMappings;
import beans.gmfmap.linkMetaFeature;
import beans.gmfmap.links;
import beans.gmfmap.nodes;
import beans.gmfmap.ownedChild;
import beans.gmfmap.palette;
import beans.gmfmap.sourceEnd;
import beans.gmfmap.sourceMetaFeature;
import beans.gmfmap.targetEnd;
import beans.gmfmap.tool;
import beans.gmfmap.value;

import com.ctc.wstx.sr.NsDefaultProvider;
import com.thoughtworks.xstream.XStream;

public class ParserXML_GMFMap {

	private static XStream xs;
	private String xml;

	private static gmfmap pack;

	private ArrayList<nodes> nodes;
	private ArrayList<children> children;
	private ArrayList<links> links;
	private ArrayList<initializers> initializers;
	private ArrayList<feature> feature;
	//	private ArrayList<labels> labels;

	private diagram newDiagram;

	private int ContAux = 0;

	public ParserXML_GMFMap(){
		xs = new XStream();
		pack = new gmfmap();

		nodes= new ArrayList<nodes>();
		children= new ArrayList<children>();
		links= new ArrayList<links>();
		initializers = new ArrayList<initializers>();
		feature = new ArrayList<feature>();
		//		labels = new ArrayList<labels>();

		createAlias();
	}

	public void createAlias() {
		//All 
		//Add coleo no classifier
		xs.addImplicitCollection(domainInitializer.class, "initializers");
		//		xs.addImplicitCollection(initializers.class, "feature");
		xs.addImplicitCollection(gmfmap.class, "nodes");
		xs.addImplicitCollection(ownedChild.class, "children", "children", children.class);
		xs.addImplicitCollection(gmfmap.class, "links");
		//		xs.addImplicitCollection(gmfgraph.class, "labels");
		//		xs.addImplicitCollection(figures.class, "descriptors");

		//GMFMap
		xs.alias("gmfmap:Mapping", gmfmap.class);
		xs.aliasField("xmi:version", gmfmap.class, "version");
		xs.aliasField("xmlns:xmi", gmfmap.class, "xmi");
		xs.aliasField("xmlns:xsi", gmfmap.class, "xsi");
		xs.aliasField("xmlns:ecore", gmfmap.class, "xmlsecore");
		xs.aliasField("xmlns:gmfmap", gmfmap.class, "xmlsGmfmap");
		xs.aliasField("xmlns:gmftool", gmfmap.class, "xmlsGmftool");
		xs.useAttributeFor(gmfmap.class, "version");
		xs.useAttributeFor(gmfmap.class, "xmi");
		xs.useAttributeFor(gmfmap.class, "xsi");
		xs.useAttributeFor(gmfmap.class, "xmlsecore");
		xs.useAttributeFor(gmfmap.class, "xmlsGmfmap");
		xs.useAttributeFor(gmfmap.class, "xmlsGmftool");

		//Nodes
		xs.alias("nodes", nodes.class);
		xs.useAttributeFor(nodes.class, "containmentFeature");
		xs.useAttributeFor(nodes.class, "ownedChild");

		//containmentFeature
		xs.alias("containmentFeature", containmentFeature.class);
		xs.aliasField("href", containmentFeature.class, "href");
		xs.useAttributeFor(containmentFeature.class, "href");

		//ownedChild
		xs.alias("ownedChild", ownedChild.class);

		//domainMetaElement
		xs.alias("domainMetaElement", domainMetaElement.class);
		xs.aliasField("href", domainMetaElement.class, "href");
		xs.useAttributeFor(domainMetaElement.class, "href");

		//domainSpecialization
		xs.alias("domainSpecialization", domainSpecialization.class);
		xs.aliasField("body", domainSpecialization.class, "body");
		xs.useAttributeFor(domainSpecialization.class, "body");

		//domainInitializer
		xs.alias("domainInitializer", domainInitializer.class);
		xs.aliasField("xsi:type", domainInitializer.class, "type");
		xs.useAttributeFor(domainInitializer.class, "type");

		//initializers
		xs.alias("initializers", initializers.class);
		xs.aliasField(" xsi:type", initializers.class, "type");
		xs.aliasField("value", initializers.class, "value");
		xs.useAttributeFor(initializers.class, "type");
		xs.useAttributeFor(initializers.class, "value");

		//value
		xs.alias("value", value.class);
		xs.aliasField("body", value.class, "body");
		xs.useAttributeFor(value.class, "body");

		//feature
		xs.alias("feature", feature.class);
		xs.aliasField("xsi:type", feature.class, "type");
		xs.aliasField("href", feature.class, "href");
		xs.useAttributeFor(feature.class, "type");
		xs.useAttributeFor(feature.class, "href");

		//labelMappings
		xs.alias("labelMappings", labelMappings.class);
		xs.aliasField(" xsi:type", labelMappings.class, "type");
		xs.aliasField("readOnly", labelMappings.class, "readOnly");
		xs.aliasField("diagramLabel", labelMappings.class, "diagramLabel");
		xs.aliasField("features", labelMappings.class, "feature");
		xs.useAttributeFor(labelMappings.class, "type");
		xs.useAttributeFor(labelMappings.class, "readOnly");

		//diagramLabel
		xs.alias("diagramLabel", diagramLabel.class);
		xs.aliasField("href", diagramLabel.class, "href");
		xs.useAttributeFor(diagramLabel.class, "href");

		//tool
		xs.alias("tool", tool.class);
		xs.aliasField("xsi:type", tool.class, "type");
		xs.aliasField("href", tool.class, "href");
		xs.useAttributeFor(tool.class, "type");
		xs.useAttributeFor(tool.class, "href");

		//diagramNode
		xs.alias("diagramNode", diagramNode.class);
		xs.aliasField("href", diagramNode.class, "href");
		xs.useAttributeFor(diagramNode.class, "href");

		//links
		xs.alias("links", links.class);
		xs.aliasField("domainMetaElement", links.class, "domainMetaElement");
		xs.aliasField("domainSpecialization", links.class, "domainSpecialization");
		xs.aliasField("domainInitializer", links.class, "domainInitializer");
		xs.aliasField("labelMappings", links.class, "labelMappings");
		xs.aliasField("containmentFeature", links.class, "containmentFeature");
		xs.aliasField("diagramLink", links.class, "diagramLink");
		xs.aliasField("sourceMetaFeature", links.class, "sourceMetaFeature");
		xs.aliasField("linkMetaFeature", links.class, "linkMetaFeature");
		xs.aliasField("creationConstraints", links.class, "creationConstraints");

		//		//creationConstraints
		//		xs.alias("creationConstraints", creationConstraints.class);
		//		xs.aliasField("href", creationConstraints.class, "href");
		//		xs.useAttributeFor(creationConstraints.class, "href");

		//sourceEnd
		xs.alias("sourceEnd", sourceEnd.class);
		xs.aliasField("body", sourceEnd.class, "body");
		xs.useAttributeFor(sourceEnd.class, "body");

		//targetEnd
		xs.alias("targetEnd", targetEnd.class);
		xs.aliasField("body", targetEnd.class, "body");
		xs.useAttributeFor(targetEnd.class, "body");

		//diagram
		xs.alias("diagram", diagram.class);
		xs.aliasField("diagramCanvas", diagram.class, "diagramCanvas");
		xs.aliasField("domainModel", diagram.class, "domainModel");
		xs.aliasField("domainMetaElement", diagram.class, "domainMetaElement");
		xs.aliasField("palette", diagram.class, "palette");

		//diagramCanvas
		xs.alias("diagramCanvas", diagramCanvas.class);
		xs.aliasField("href", diagramCanvas.class, "href");
		xs.useAttributeFor(diagramCanvas.class, "href");

		//domainModel
		xs.alias("domainModel", domainModel.class);
		xs.aliasField("href", domainModel.class, "href");
		xs.useAttributeFor(domainModel.class, "href");

		//domainMetaElement
		xs.alias("domainMetaElement", domainMetaElement.class);
		xs.aliasField("href", domainMetaElement.class, "href");
		xs.useAttributeFor(domainMetaElement.class, "href");

		//palette
		xs.alias("palette", palette.class);
		xs.aliasField("href", palette.class, "href");
		xs.useAttributeFor(palette.class, "href");

		//diagramLink
		xs.alias("diagramLink", diagramLink.class);
		xs.aliasField("href", diagramLink.class, "href");
		xs.useAttributeFor(diagramLink.class, "href");

		//sourceMetaFeature
		xs.alias("sourceMetaFeature", sourceMetaFeature.class);
		xs.aliasField("xsi:type", sourceMetaFeature.class, "type");
		xs.aliasField("href", sourceMetaFeature.class, "href");
		xs.useAttributeFor(sourceMetaFeature.class, "type");
		xs.useAttributeFor(sourceMetaFeature.class, "href");

		//linkMetaFeature
		xs.alias("linkMetaFeature", linkMetaFeature.class);
		xs.aliasField("xsi:type", linkMetaFeature.class, "type");
		xs.aliasField("href", linkMetaFeature.class, "href");
		xs.useAttributeFor(linkMetaFeature.class, "type");
		xs.useAttributeFor(linkMetaFeature.class, "href");

		//compartment
		xs.alias("compartment", compartment.class);
		xs.aliasField("href", compartment.class, "href");
		xs.useAttributeFor(compartment.class, "href");

		//compartments
		xs.alias("compartments", compartments.class);
		xs.aliasField("children", compartments.class, "children");
		xs.aliasField("compartment", compartments.class, "compartment");
		xs.useAttributeFor(compartments.class, "children");
		xs.useAttributeFor(compartments.class, "compartment");

		//children
		xs.alias("children", children.class);
		xs.aliasField("compartment", children.class, "compartment");
		xs.useAttributeFor(children.class, "compartment");

		//childrenFeature
		xs.alias("childrenFeature", childrenFeature.class);
		xs.aliasField("href", childrenFeature.class, "href");
		xs.useAttributeFor(childrenFeature.class, "href");
	}

	public nodes createNode(String ecore, String refContainmentFeature, String refDomainMetaElement,
			String oclDomainSpecialization, String refDiagramLabel, String refDiagramLabelFeature,
			int indexToolGroup, int indexCreationTool, String node, boolean compartment){

		nodes newNode = new nodes();

		containmentFeature newCF = new containmentFeature();
		newCF.setHref(ecore + ".ecore#//" + refContainmentFeature); //Model/actors
		newNode.setContainmentFeature(newCF);

		ownedChild newOwnedChild = new ownedChild();

		domainMetaElement newDME = new domainMetaElement();
		newDME.setHref(ecore + ".ecore#//" + refDomainMetaElement);

		domainSpecialization newDS = new domainSpecialization();
		newDS.setBody(oclDomainSpecialization);

		domainInitializer newDI = new domainInitializer();
		newDI.setType("gmfmap:FeatureSeqInitializer");

		if (initializers!=null) {
			for (int i = 0; i < initializers.size(); i++) {
				newDI.getInitializers().add(initializers.get(i));
			}
		}

		newOwnedChild.setDomainMetaElement(newDME);
		newOwnedChild.setDomainSpecialization(newDS);
		newOwnedChild.setDomainInitializer(newDI);

		labelMappings newLM = new labelMappings();
		newLM.setType("gmfmap:FeatureLabelMapping");

		diagramLabel newDiagramLabel = new diagramLabel();
		newDiagramLabel.setHref(ecore + ".gmfgraph#" + refDiagramLabel + "Name");

		feature newDLFeature = new feature();
		newDLFeature.setHref(ecore + ".ecore#//" + refDiagramLabelFeature);

		newLM.setDiagramLabel(newDiagramLabel);
		newLM.setFeature(newDLFeature);

		newOwnedChild.setLabelMappings(newLM);

		tool newTool = new tool();
		newTool.setType("gmftool:CreationTool");
		newTool.setHref(ecore + ".gmftool#//@palette/@tools." + indexToolGroup + "/@tools." + indexCreationTool);

		newOwnedChild.setTool(newTool);

		diagramNode newDN = new diagramNode();
		newDN.setHref(ecore + ".gmfgraph#" + node);

		newOwnedChild.setDiagramNode(newDN);
		newNode.setOwnedChild(newOwnedChild);
		
		if (compartment) {

			newOwnedChild.setChildren(children);
			compartment comp = new compartment();
			comp.setHref(ecore + ".gmfgraph#" + node + "Compartment");

			compartments compts = new compartments();
			// compts.setChildren("//@nodes.0/@ownedChild/@children.0");
			compts.setCompartment(comp);

			newOwnedChild.setCompartments(compts);
			nodes.add(newNode);
		}else if(refContainmentFeature.contains("mm")) {
			int refChild = 0;
			String childContainmentFeature = "Compartment/elementsmc";
			createChild(ecore, "//@nodes.0/@ownedChild/@compartments.0", refChild, childContainmentFeature, refDomainMetaElement, oclDomainSpecialization,
					refDiagramLabel, refDiagramLabelFeature, indexToolGroup, indexCreationTool, node);
			nodes.add(newNode);
		} else if(refContainmentFeature.contains("compartment")) {
			int refChild = 0;
			String childContainmentFeature = "Compartment/elementsCompartment";
			createChild(ecore, "//@nodes.0/@ownedChild/@compartments.0", refChild, childContainmentFeature, refDomainMetaElement, oclDomainSpecialization,
					refDiagramLabel, refDiagramLabelFeature, indexToolGroup, indexCreationTool, node);
		} else {
			nodes.add(newNode);
		}
		return newNode;
	}

	public children createChild(String ecore, String compartment, int refChild, String refContainmentFeature, String refDomainMetaElement,
			String oclDomainSpecialization, String refDiagramLabel, String refDiagramLabelFeature,
			int indexToolGroup, int indexCreationTool, String node){

		children newChild = new children();

		newChild.setCompartment(compartment);
		containmentFeature newCF = new containmentFeature();
		newCF.setHref(ecore + ".ecore#//" + refContainmentFeature); 
		newChild.setContainmentFeature(newCF);

		childrenFeature cf = new childrenFeature();
		cf.setHref(ecore + ".ecore#//" + refContainmentFeature);

		ownedChild newOwnedChild = new ownedChild();

		domainMetaElement newDME = new domainMetaElement();
		newDME.setHref(ecore + ".ecore#//" + refDomainMetaElement);

		domainSpecialization newDS = new domainSpecialization();
		newDS.setBody(oclDomainSpecialization);

		domainInitializer newDI = new domainInitializer();
		newDI.setType("gmfmap:FeatureSeqInitializer");

		if (initializers!=null) {
			for (int i = 0; i < initializers.size(); i++) {
				newDI.getInitializers().add(initializers.get(i));
			}
		}
		newOwnedChild.setDomainSpecialization(newDS);
		newOwnedChild.setDomainInitializer(newDI);
		newOwnedChild.setDomainMetaElement(newDME);


		labelMappings newLM = new labelMappings();
		newLM.setType("gmfmap:FeatureLabelMapping");

		diagramLabel newDiagramLabel = new diagramLabel();
		newDiagramLabel.setHref(ecore + ".gmfgraph#" + refDiagramLabel + "Name");

		feature newDLFeature = new feature();
		newDLFeature.setHref(ecore + ".ecore#//" + refDiagramLabelFeature);

		newLM.setDiagramLabel(newDiagramLabel);
		newLM.setFeature(newDLFeature);

		newOwnedChild.setLabelMappings(newLM);

		tool newTool = new tool();
		newTool.setType("gmftool:CreationTool");
		newTool.setHref(ecore + ".gmftool#//@palette/@tools." + indexToolGroup + "/@tools." + indexCreationTool);

		newOwnedChild.setTool(newTool);

		diagramNode newDN = new diagramNode();
		newDN.setHref(ecore + ".gmfgraph#" + node);

		newOwnedChild.setDiagramNode(newDN);

		newChild.setOwnedChild(newOwnedChild);

		children.add(newChild);

		return newChild;
	}

	public links createLinks(String ecore, String refContainmentFeature, String refDomainMetaElement,
			String oclDomainSpecialization, String refDiagramLabel, String refDiagramLabelFeature,
			int indexToolGroup, int indexCreationTool, String node, String refSourceMeta, String refLinkMeta,
			boolean domainInit, String oclSource, String oclTarget){
		links newLinks = new links();

		containmentFeature newCF = new containmentFeature();
		newCF.setHref(ecore + ".ecore#//" + refContainmentFeature); //Model/actors
		newLinks.setContainmentFeature(newCF);

		domainMetaElement newDME = new domainMetaElement();
		newDME.setHref(ecore + ".ecore#//" + refDomainMetaElement);
		newLinks.setDomainMetaElement(newDME);

		sourceMetaFeature newsourceMetaFeature = new sourceMetaFeature();
		newsourceMetaFeature.setType("ecore:EReference");
		newsourceMetaFeature.setHref(ecore + ".ecore#//" + refSourceMeta);
		newLinks.setSourceMetaFeature(newsourceMetaFeature);

		linkMetaFeature newLinkMetaFeature = new linkMetaFeature();
		newLinkMetaFeature.setType("ecore:EReference");
		newLinkMetaFeature.setHref(ecore + ".ecore#//" + refLinkMeta);
		newLinks.setLinkMetaFeature(newLinkMetaFeature);

		tool newTool = new tool();
		newTool.setType("gmftool:CreationTool");
		newTool.setHref(ecore + ".gmftool#//@palette/@tools." + indexToolGroup + "/@tools." + indexCreationTool);
		newLinks.setTool(newTool);

		diagramLink newDL = new diagramLink();
		newDL.setHref(ecore + ".gmfgraph#" + node);
		newLinks.setDiagramLink(newDL);

		if (oclDomainSpecialization!=null) {
			domainSpecialization newDS = new domainSpecialization();
			newDS.setBody(oclDomainSpecialization);
			newLinks.setDomainSpecialization(newDS);
		}

		if (domainInit) {
			domainInitializer newDI = new domainInitializer();
			newDI.setType("gmfmap:FeatureSeqInitializer");

			if (initializers!=null) {
				for (int i = 0; i < initializers.size(); i++) {
					newDI.getInitializers().add(initializers.get(i));
				}
			}
			newLinks.setDomainInitializer(newDI);
		}

		if (refDiagramLabel!=null) {

			labelMappings newLM = new labelMappings();
			newLM.setType("gmfmap:FeatureLabelMapping");
			newLM.setReadOnly("true");

			diagramLabel newDiagramLabel = new diagramLabel();
			newDiagramLabel.setHref(ecore + ".gmfgraph#" + refDiagramLabel + "Name");

			feature newDLFeature = new feature();
			newDLFeature.setHref(ecore + ".ecore#//" + refDiagramLabelFeature);

			newLM.setDiagramLabel(newDiagramLabel);
			newLM.setFeature(newDLFeature);
			newLinks.setLabelMappings(newLM);
		}

		creationConstraints newcreationConstraints = new creationConstraints();
		sourceEnd newSourceEnd = new sourceEnd();
		newSourceEnd.setBody(oclSource);
		newcreationConstraints.setSourceEnd(newSourceEnd);
		if (oclTarget!=null) {
			targetEnd newTargetEnd = new targetEnd();
			newTargetEnd.setBody(oclTarget);
			newcreationConstraints.setTargetEnd(newTargetEnd);
		}
		newLinks.setCreationConstraints(newcreationConstraints);
		links.add(newLinks);

		return newLinks;
	}

	public void createInitializers(String ecore, String ref, String ocl){
		initializers newInitializers = new initializers();
		newInitializers.setType("gmfmap:FeatureValueSpec");

		value newValue = new value();
		newValue.setBody(ocl);

		feature newFeature = new feature();
		newFeature.setType("ecore:EAttribute");
		newFeature.setHref(ecore + ".ecore#//" + ref);

		newInitializers.setFeature(newFeature);
		newInitializers.setValue(newValue);

		initializers.add(newInitializers);
	}

	public void resetAll(){
		initializers.removeAll(initializers);
	}

	public void createDiagram(String ecoreName){

		newDiagram = new diagram();

		diagramCanvas newDiagramCanvas = new diagramCanvas();
		newDiagramCanvas.setHref(ecoreName + ".gmfgraph#" + ecoreName);

		domainModel newDomainModel = new domainModel();
		newDomainModel.setHref(ecoreName + ".ecore#/");

		domainMetaElement newDomainMetaElement = new  domainMetaElement();
		newDomainMetaElement.setHref(ecoreName + ".ecore#//Model");

		palette newPalette = new palette();
		newPalette.setHref(ecoreName + ".gmftool#//@palette");

		newDiagram.setDiagramCanvas(newDiagramCanvas);
		newDiagram.setDomainModel(newDomainModel);
		newDiagram.setDomainMetaElement(newDomainMetaElement);
		newDiagram.setPalette(newPalette);

	}

	public void createXML(){
	
		//ePackage
		pack.setVersion("2.0");
		pack.setXmi("http://www.omg.org/XMI");
		pack.setXsi("http://www.w3.org/2001/XMLSchema-instance");
		pack.setXmlsecore("http://www.eclipse.org/emf/2002/Ecore");
		pack.setXmlsGmfmap("http://www.eclipse.org/gmf/2008/mappings");
		pack.setXmlsGmftool("http://www.eclipse.org/gmf/2005/ToolDefinition");

		if (nodes!=null) {
			for (int i = 0; i < nodes.size(); i++) {
				// Correo das refs
				if (nodes.get(i).getOwnedChild().getCompartments() != null) {
					ArrayList<children> children2 = new ArrayList<children>();
					for (int j = 0; j < children.size(); j++) {
						children temp = new children();
						temp.setCompartment("//@nodes."+i+"/@ownedChild/@compartments.0");
						temp.setContainmentFeature(children.get(j).getContainmentFeature());
						temp.setOwnedChild(children.get(j).getOwnedChild());
						children2.add(temp);
					}
					nodes.get(i).getOwnedChild().setChildren(children2);
				}
				pack.getNodes().add(nodes.get(i));
			}
		}

		if (links!=null) {
			for (int i = 0; i < links.size(); i++) {
				//System.out.println(links.get(i).getContainmentFeature().getHref());
				pack.getLinks().add(links.get(i));
			}
		}
		
		pack.setDiagram(newDiagram);
		xs.setMode(XStream.NO_REFERENCES);
		xml = xs.toXML(pack);  
		//	System.out.println(xml);
	}

	public void createFileGMFGraph(String path, String namefile){
		File file = new File(path + "\\" + namefile + ".gmfmap");
		try {
			FileWriter fw = new FileWriter(file);
			fw.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n");
			fw.write(xml);
			fw.flush();
			fw.close();
			System.out.println("gmfmap criado");
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}
}