package Injection;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;

import com.thoughtworks.xstream.XStream;

import beans.metamodel.details;
import beans.metamodel.eAnnotation;
import beans.metamodel.eClassifier;
import beans.metamodel.eLiteral;
import beans.metamodel.ePackage;
import beans.metamodel.eStructuralFeature;

public class ParserXML_Metamodel {
	
	private static XStream xs;
	private String xml;
	
	private static ePackage pack;
	private static eClassifier model, nodeObject, elementModel, elementCompartment, ElementMC, element, relationship, compartment;
	private static eClassifier enumCompartmentType, enumElementModelType, enumElementCompartmentType, enumElementMCType;
	
	public ParserXML_Metamodel(){
		xs = new XStream();
		pack = new ePackage();
		
		//Create eClassifiers
		
		createAlias();
	    createCore();
	}
	
	public void createAlias(){
		
		//All 
		//Add coleo no classifier
		xs.addImplicitCollection(ePackage.class, "eClass");
		xs.addImplicitCollection(eClassifier.class, "eStruct");
		xs.addImplicitCollection(eClassifier.class, "eAnnon");
		xs.addImplicitCollection(eClassifier.class, "eLiteral");
		xs.addImplicitCollection(eAnnotation.class, "details");
		
		//ePackage
		xs.alias("ecore:EPackage", ePackage.class);
		xs.aliasField("xmi:version", ePackage.class, "version");
		xs.aliasField("xmlns:xmi", ePackage.class, "xmi");
		xs.aliasField("xmlns:xsi", ePackage.class, "xsi");
		xs.aliasField("xmlns:ecore", ePackage.class, "ecore");
		xs.aliasField("name", ePackage.class, "name");
		xs.aliasField("nsURI", ePackage.class, "URI");
		xs.aliasField("nsPrefix", ePackage.class, "prefix");
		
		xs.useAttributeFor(ePackage.class, "version");
		xs.useAttributeFor(ePackage.class, "xmi");
		xs.useAttributeFor(ePackage.class, "xsi");
		xs.useAttributeFor(ePackage.class, "ecore");
		xs.useAttributeFor(ePackage.class, "name");
		xs.useAttributeFor(ePackage.class, "URI");
		xs.useAttributeFor(ePackage.class, "prefix");
		
		//eClassifier
		xs.alias("eClassifiers", eClassifier.class);
		xs.aliasField("xsi:type", eClassifier.class, "type");
		xs.aliasField("eSuperTypes", eClassifier.class, "superType");
		xs.useAttributeFor(eClassifier.class, "name");
		xs.useAttributeFor(eClassifier.class, "type");
		xs.useAttributeFor(eClassifier.class, "superType");
		xs.useAttributeFor(eClassifier.class, "instanceClassName");
		
		//eStructureFeature
		xs.alias("eStructuralFeatures", eStructuralFeature.class);
		xs.aliasField("xsi:type", eStructuralFeature.class, "xsitype");
		xs.aliasField("eType", eStructuralFeature.class, "etype");
		xs.useAttributeFor(eStructuralFeature.class, "name");
		xs.useAttributeFor(eStructuralFeature.class, "xsitype");
		xs.useAttributeFor(eStructuralFeature.class, "unique");
		xs.useAttributeFor(eStructuralFeature.class, "unsettable");
		xs.useAttributeFor(eStructuralFeature.class, "upperBound");
		xs.useAttributeFor(eStructuralFeature.class, "etype");
		xs.useAttributeFor(eStructuralFeature.class, "containment");
		
		//eAnnotation
		xs.alias("eAnnotations", eAnnotation.class);
		xs.useAttributeFor(eAnnotation.class, "source");
		
		//details
		xs.alias("details", details.class);
		xs.useAttributeFor(details.class, "key");
		xs.useAttributeFor(details.class, "value");
		
		//eLiteral
		xs.alias("eLiterals", eLiteral.class);
		xs.useAttributeFor(eLiteral.class, "name");
		xs.useAttributeFor(eLiteral.class, "value");
	}
	
	public void createCore(){
		
		
		//ENUMCompartment
		//eClassifier
		enumCompartmentType = new eClassifier();
		enumCompartmentType.setName("CompartmentType");
		enumCompartmentType.setType("ecore:EEnum");
		
		//ENUMElementMC
		//eClassifier
		enumElementMCType = new eClassifier();
		enumElementMCType.setName("ElementMCType");
		enumElementMCType.setType("ecore:EEnum");
		
		//MODEL
		//eStructuralFeatures
		eStructuralFeature atTitle = new eStructuralFeature();
		atTitle.setXsitype("ecore:EAttribute");
		atTitle.setName("title");
		atTitle.setEtype("ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString");
		
		eStructuralFeature refActors = new eStructuralFeature();
		refActors.setXsitype("ecore:EReference");
		refActors.setName("actors");
		refActors.setEtype("#//Compartment");
		refActors.setUpperBound("-1");
		refActors.setContainment("true");
		
		eStructuralFeature refElementMC = new eStructuralFeature();
		refElementMC.setXsitype("ecore:EReference");
		refElementMC.setName("elementsmm");
		refElementMC.setEtype("#//ElementMC");
		refElementMC.setUpperBound("-1");
		refElementMC.setContainment("true");
		
		//MODEL
		//eClassifier
		model = new eClassifier();
		model.setName("Model");
		model.setType("ecore:EClass");
		model.getEStruct().add(atTitle);
		model.getEStruct().add(refActors);
		model.getEStruct().add(refElementMC);
		
		//NODEOBJECT
		//eStructuralFeatures NodeObject
		eStructuralFeature atNameNodeObject = new eStructuralFeature();
		atNameNodeObject.setXsitype("ecore:EAttribute");
		atNameNodeObject.setName("name");
		atNameNodeObject.setEtype("ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString");
		
		//NODEOBJECT
		//eClassifier
		nodeObject = new eClassifier();
		nodeObject.setName("NodeObject");
		nodeObject.setType("ecore:EClass");
		nodeObject.getEStruct().add(atNameNodeObject);
		
		//ElementMC
		//eStructuralFeatures
		eStructuralFeature atNameElementMC = new eStructuralFeature();
		atNameElementMC.setXsitype("ecore:EAttribute");
		atNameElementMC.setName("type");
		atNameElementMC.setEtype("#//ElementMCType");
		
		//ElementMC
		//eClassifier
		ElementMC = new eClassifier();
		ElementMC.setName("ElementMC");
		ElementMC.setType("ecore:EClass");
		ElementMC.setSuperType("#//IntentionalElement");
		ElementMC.getEStruct().add(atNameElementMC);
		
		//ELEMENT
		//eClassifier
		element = new eClassifier();
		element.setName("IntentionalElement");
		element.setType("ecore:EClass");
		element.setSuperType("#//NodeObject");
		
		//RELATIONSHIP
		//eClassifier
		relationship = new eClassifier();
		relationship.setName("Relationship");
		relationship.setType("ecore:EClass");
		
		//Compartment
		//eStructuralFeatures
		eStructuralFeature atTypeCompartment = new eStructuralFeature();
		atTypeCompartment.setXsitype("ecore:EAttribute");
		atTypeCompartment.setName("type");
		atTypeCompartment.setUnique("false");
		atTypeCompartment.setUnsettable("true");
		atTypeCompartment.setEtype("#//CompartmentType");
		
		eStructuralFeature refElementMCCompartment = new eStructuralFeature();
		refElementMCCompartment.setXsitype("ecore:EReference");
		refElementMCCompartment.setName("elementsmc");
		refElementMCCompartment.setEtype("#//ElementMC");
		refElementMCCompartment.setUpperBound("-1");
		refElementMCCompartment.setContainment("true");
		
		//Compartment
		//eClassifier
		compartment = new eClassifier();
		compartment.setName("Compartment");
		compartment.setType("ecore:EClass");
		compartment.setSuperType("#//NodeObject");
		compartment.getEStruct().add(atTypeCompartment);
		compartment.getEStruct().add(refElementMCCompartment);
		
	}
	
	public void createXML(){
		
		//ePackage
		pack.setVersion("2.0");
		pack.setXmi("http://www.omg.org/XMI");
		pack.setXsi("http://www.w3.org/2001/XMLSchema-instance");
		pack.setEcore("http://www.eclipse.org/emf/2002/Ecore");
		pack.setName("istarModel");
		pack.setURI("http://www.cin.ufpe.br/~bss/istar");
		pack.setPrefix("istarModel");
		pack.getEClass().add(model);
		pack.getEClass().add(nodeObject);
		pack.getEClass().add(compartment);
		pack.getEClass().add(relationship);
		pack.getEClass().add(element);
		pack.getEClass().add(ElementMC);
		pack.getEClass().add(enumCompartmentType);
		pack.getEClass().add(enumElementMCType);
		
		xml = xs.toXML(pack);  
	}
	
	public void createFile(String path, String namefile){
		File file = new File(path + "\\" + namefile + ".ecore");
		try {
			FileWriter fw = new FileWriter(file);
			fw.write("<?xml version=\"1.0\" encoding=\"UTF-8\"?>" + "\n");
			fw.write(xml);
			fw.flush();
			fw.close();
			System.out.println("Ecore criado");
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}
	
	public static XStream getXs() {
		return xs;
	}
	
	public static void setXs(XStream xs) {
		ParserXML_Metamodel.xs = xs;
	}

	public static ePackage getPack() {
		return pack;
	}

	public static void setPack(ePackage pack) {
		ParserXML_Metamodel.pack = pack;
	}

	public static eClassifier getModel() {
		return model;
	}

	public static void setModel(eClassifier model) {
		ParserXML_Metamodel.model = model;
	}

	public static eClassifier getNodeObject() {
		return nodeObject;
	}

	public static void setNodeObject(eClassifier nodeObject) {
		ParserXML_Metamodel.nodeObject = nodeObject;
	}

	public static eClassifier getElementModel() {
		return elementModel;
	}

	public static void setElementModel(eClassifier elementModel) {
		ParserXML_Metamodel.elementModel = elementModel;
	}

	public static eClassifier getElementCompartment() {
		return elementCompartment;
	}

	public static void setElementCompartment(eClassifier elementCompartment) {
		ParserXML_Metamodel.elementCompartment = elementCompartment;
	}

	public static eClassifier getElementMC() {
		return ElementMC;
	}

	public static void setElementMC(eClassifier ElementMC) {
		ParserXML_Metamodel.ElementMC = ElementMC;
	}

	public static eClassifier getElement() {
		return element;
	}

	public static void setElement(eClassifier element) {
		ParserXML_Metamodel.element = element;
	}

	public static eClassifier getRelationship() {
		return relationship;
	}

	public static void setRelationship(eClassifier relationship) {
		ParserXML_Metamodel.relationship = relationship;
	}

	public static eClassifier getCompartment() {
		return compartment;
	}

	public static void setCompartment(eClassifier compartment) {
		ParserXML_Metamodel.compartment = compartment;
	}
	
	public static eClassifier getEnumCompartmentType() {
		return enumCompartmentType;
	}

	public static void setEnumCompartmentType(eClassifier enumCompartmentType) {
		ParserXML_Metamodel.enumCompartmentType = enumCompartmentType;
	}

	public static eClassifier getEnumElementModelType() {
		return enumElementModelType;
	}

	public static void setEnumElementModelType(eClassifier enumElementModelType) {
		ParserXML_Metamodel.enumElementModelType = enumElementModelType;
	}

	public static eClassifier getEnumElementCompartmentType() {
		return enumElementCompartmentType;
	}

	public static void setEnumElementCompartmentType(eClassifier enumElementCompartmentType) {
		ParserXML_Metamodel.enumElementCompartmentType = enumElementCompartmentType;
	}

	public static eClassifier getEnumElementMCType() {
		return enumElementMCType;
	}

	public static void setEnumElementMCType(eClassifier enumElementMCType) {
		ParserXML_Metamodel.enumElementMCType = enumElementMCType;
	}

//	public static void main(String[] args) {
//		ParserXML_Metamodel px = new ParserXML_Metamodel();
//		px.createAlias();
//		px.createCore();
//		
//		NewConstructor nc = new NewConstructor();
//		nc.setNewElement("coco", "modelCompartment");
//		nc.setNewElement("coco2", "modelCompartment");
//		nc.setCompartmentAttribute("new constructor");
//		nc.createEnum("Teste");
//		nc.createAtributte("new constructor",  "at4", "ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString");
//		nc.createAtributte("new constructor",  "at5", "seiladoido");
		
//		nc.setElementAttribute("Testao", "modelCompartment");
//		nc.createAtributte("Testao", "atributo de teste","testandoENUM");
		
//		nc.setNewLink("NewLink", "model", "-1");
//		nc.createAtributte("NewLink", "testeARLInk", "aa");
//		nc.createSource("NewLink","source", "Element", "false");
//		nc.createTarget("NewLink","source", "Element", "false");
		
//		px.createXML();
//		px.createFile("D:/Projetos Java/GMF/SR/iStar-PL", "teste");
		
//		MappingIstarConfig mc = new MappingIstarConfig();
//		mc.selectCompartmentPredefined("teste");
//		mc.selectCompartmentPredefined("teste");
//		mc.selectElementPredefined("seila");
//		mc.selectRelationshipPredefined("MeansEndLink", null);
//		mc.selectRelationshipPredefined("TaskDecompositionLink", null);
//		
//		ArrayList<String> s2 = new ArrayList<String>();
//		s2.add("make");
//		s2.add("break");
//		s2.add("help");
//		mc.selectRelationshipPredefined("Contribution Link", s2);
//		
//		ArrayList<String> s4 = new ArrayList<String>();
//		s4.add("commited");
//		s4.add("open");
//		s4.add("critical");
//		mc.selectRelationshipPredefined("dependency Link", s4);
//		
//		ArrayList<String> s5 = new ArrayList<String>();
//		s5.add("isa");
//		s5.add("ispartof");
//		mc.selectRelationshipPredefined("Actor Association", s5);
		
//	}
}
