package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class ActorLinkIsPartOf implements Link{
	
	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;

	public ActorLinkIsPartOf(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;
		
		cim.indexEspecializationActorLink += 1;
		cim.associations.add("ispartof");
		
	}
	
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "ActorLink", pxGT.createSmallIcon("Imagem04", "cin.ufpe.br.wiki.edit"));
	}
	
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsLinkPolyline(element);
		pxGG.createDescriptorsLinkLabel(element);
	}

	public void gmfmapInjection(String name){
		//gmfmap
		pxGM.createInitializers(name, "ActorLink/type", "ActorLinkType::ISPARTOF");
		pxGM.createInitializers(name, "ActorLink/name", "''");
		pxGM.createLinks(name, "Model/actorlink", "ActorLink", 
				"self.type=ActorLinkType::ISPARTOF", "IsPartOf", "ActorLink/name",
				pxGT.getToolGroup("ActorLink"), cim.indexEspecializationActorLink, "IsPartOf", "ActorLink/source",
				"ActorLink/target", true, "self <> oppositeEnd", null);
		pxGM.resetAll();
	}

}
