package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class ContributionLinkOr  implements Link{

	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;

	public ContributionLinkOr(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;

		cim.indexEspecializationContribution += 1;
		cim.contributions.add("or");
	}
	
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "Contribution Links", pxGT.createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
	}
	
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsLinkPolyline(element);
		pxGG.createDescriptorsLinkLabel(element);
	}

	public void gmfmapInjection(String element){
		pxGM.createInitializers(element, "ContributionLink/type", "ContributionType::OR");
		pxGM.createInitializers(element, "ContributionLink/name", "''");
		if (cim.strContriSource==null && cim.strContriTarget==null) {
			pxGM.createLinks(element, "Compartment/contributionlink", "ContributionLink", 
					"self.type=ContributionType::OR", "Or", "ContributionLink/name",
					pxGT.getToolGroup("Contribution Links"), cim.indexEspecializationContribution, "Or", "ContributionLink/source",
					"ContributionLink/target", true, "self <> oppositeEnd", null);
		}else if (cim.strContriConstraint.equals("") && (cim.strContriSource!=null && cim.strContriTarget!=null)) {
			pxGM.createLinks(element, "Compartment/contributionlink", "ContributionLink", 
					"self.type=ContributionType::OR", "Or", "ContributionLink/name",
					pxGT.getToolGroup("Contribution Links"), cim.indexEspecializationContribution, "Or", "ContributionLink/source",
					"ContributionLink/target", true, cim.strContriSource.toString(), cim.strContriTarget.toString());
		}else{
			pxGM.createLinks(element, "Compartment/contributionlink", "ContributionLink", 
					"self.type=ContributionType::OR and " + cim.strContriConstraint.toString(), "Or", "ContributionLink/name",
					pxGT.getToolGroup("Contribution Links"), cim.indexEspecializationContribution, "Or", "ContributionLink/source",
					"ContributionLink/target", true, cim.strContriSource.toString(), cim.strContriTarget.toString());
		}
		pxGM.resetAll();
	}
	
}
