package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class DependencyLinkCommited implements LinkWithFlag {

	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;
	
	public DependencyLinkCommited(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;
		
		if (cim.isFlagIndexRelationship()) {
			cim.indexEspecializationRelationship += 1;
		}
		cim.Dependencys.add("commited");
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithFlag#gmftoolInjection(java.lang.String)
	 */
	@Override
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "Relationships", pxGT.createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithFlag#gmfgraphInjection(java.lang.String)
	 */
	@Override
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsLinkPolyline(element);
		pxGG.createDescriptorsLinkLabel(element);
	}

	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithFlag#gmfmapInjection(java.lang.String)
	 */
	@Override
	public void gmfmapInjection(String element){
		pxGM.createInitializers(element, "DependencyLink/type", "DependencyLinkType::COMMITED");
		pxGM.createInitializers(element, "DependencyLink/name", "''");
		if (cim.strDepenSource==null && cim.strDepenTarget==null) {
			pxGM.createLinks(element, "Model/dependencylink", "DependencyLink", 
					"self.type=DependencyLinkType::COMMITED", "Commited", "DependencyLink/name",
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "Commited", "DependencyLink/source",
					"DependencyLink/target", true, "self <> oppositeEnd", null);
		}else if (cim.strDepenConstraint.equals("") && (cim.strDepenSource!=null && cim.strDepenTarget!=null)) {
			pxGM.createLinks(element, "Model/dependencylink", "DependencyLink", 
					"self.type=DependencyLinkType::COMMITED", "Commited", "DependencyLink/name",
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "Commited", "DependencyLink/source",
					"DependencyLink/target", true, cim.strDepenSource.toString(), cim.strDepenTarget.toString());
		}else{
			pxGM.createLinks(element, "Model/dependencylink", "DependencyLink", 
					"self.type=DependencyLinkType::COMMITED and " + cim.strDepenConstraint.toString(), "Commited", "DependencyLink/name",
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "Commited", "DependencyLink/source",
					"DependencyLink/target", true, cim.strDepenSource.toString(), cim.strDepenTarget.toString());
		}
		pxGM.resetAll();
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithFlag#setFlagIndex()
	 */
	@Override
	public void setFlagIndex(){
		cim.setFlagIndexRelationship(true);
	}
	
}
