package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class MeansEndLink implements LinkWithEcore {
	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;
	
	public MeansEndLink(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;
		
		if (cim.isFlagIndexRelationship()) {
			cim.indexEspecializationRelationship += 1;
		}
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithEcore#ecoreInjection(java.lang.String)
	 */
	@Override
	public void ecoreInjection(String element){
		mc.selectRelationshipPredefined(element, null);
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithEcore#gmftoolInjection(java.lang.String)
	 */
	@Override
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "Relationships", pxGT.createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithEcore#gmfgraphInjection(java.lang.String)
	 */
	@Override
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsLinkPolyline(element);
		pxGG.createDescriptorsLinkLabel(element);
	}

	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithEcore#gmfmapInjection(java.lang.String)
	 */
	@Override
	public void gmfmapInjection(String element){
		if (cim.strMeansSource==null && cim.strMeansTarget==null) {
			pxGM.createLinks(element, "Compartment/meansendlink", "MeansEndLink", null, null, null,
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "MeansEndLink", "MeansEndLink/source",
					"MeansEndLink/target", false, "self <> oppositeEnd", null);
		}else if (cim.strMeansConstraint.equals("") && (cim.strMeansSource!=null && cim.strMeansTarget!=null)) {
			pxGM.createLinks(element, "Compartment/meansendlink", "MeansEndLink", null, null, null,
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "MeansEndLink", "MeansEndLink/source",
					"MeansEndLink/target", false, cim.strMeansSource.toString(), cim.strMeansTarget.toString());
		}else{
			pxGM.createLinks(element, "Compartment/meansendlink", "MeansEndLink", cim.strMeansConstraint.toString(), null, null,
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "MeansEndLink", "MeansEndLink/source",
					"MeansEndLink/target", false, cim.strMeansSource.toString(), cim.strMeansTarget.toString());
		}
		pxGM.resetAll();
	}
	
	/* (non-Javadoc)
	 * @see beans.coreelements.LinkWithEcore#setFlagIndex()
	 */
	@Override
	public void setFlagIndex(){
		cim.setFlagIndexRelationship(true);
	}
	
}
