package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class Position  implements Compartment {
	
	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;
	
	public Position(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;
		
		if (cim.isFlagIndexCompartment()) {
			cim.indexEspecializationCompartment += 1;
		}
		
	}
	
	public void ecoreInjection(String element){
		mc.selectCompartmentPredefined(element);
	}
	
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "Actors", pxGT.createSmallIcon("Imagem04", "cin.ufpe.br.wiki.edit"));
	}
	
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsNode(element, true,"Position", null);
	}

	public void gmfmapInjection(String element){
		pxGM.createInitializers(element, "Compartment/type", "CompartmentType::POSITION");
		pxGM.createNode(element, "Model/actors", "Compartment", "self.type=CompartmentType::POSITION", 
				"Position", "NodeObject/name", pxGT.getToolGroup("Actors"), cim.indexEspecializationCompartment, "Position", true);
		pxGM.resetAll();
	}
	
	public void setFlagIndex(){
		cim.setFlagIndexCompartment(true);
	}

}
