package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class Softgoal implements Element{
	
	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;
	
	public Softgoal(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;
		
		if (cim.isFlagIndexDependencyElements()) {
			cim.indexEspecializationDependencyElements += 1;
		}
	}
	
	public void ecoreInjection(String element){
		mc.selectElementPredefined(element);
	}
	
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "Elements", pxGT.createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
	}
	
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsNode(element, false, "Softgoal", "Model/elementsmm");
	}

	public void gmfmapInjection(String element){
		pxGM.createInitializers(element, "ElementMC/type", "ElementMCType::SOFTGOAL");
		pxGM.createNode(element, "Model/elementsmm", "ElementMC", "self.type=ElementMCType::SOFTGOAL", 
				"Softgoal", "NodeObject/name", pxGT.getToolGroup("Elements"), cim.indexEspecializationDependencyElements, "Softgoal", false);
		pxGM.resetAll();
	}
	
	public void setFlagIndex(){
		cim.setFlagIndexDependencyElements(true);
	}

}
