package beans.coreelements;

import istar_pl.actions.ConfigIstarMetamodel;
import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class TaskDecompositionLink implements LinkWithEcore {
	
	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;
	private ConfigIstarMetamodel cim;
	
	public TaskDecompositionLink(ParserXML_Metamodel pxMM, ParserXML_GMFTool pxGT,
			ParserXML_GMFGraph pxGG, ParserXML_GMFMap pxGM,
			MappingIstarConfig mc, ConfigIstarMetamodel cim) {
		super();
		this.pxMM = pxMM;
		this.pxGT = pxGT;
		this.pxGG = pxGG;
		this.pxGM = pxGM;
		this.mc = mc;
		this.cim = cim;
		
		if (cim.isFlagIndexRelationship()) {
			cim.indexEspecializationRelationship += 1;
		}
	}
	
	public void ecoreInjection(String element){
		mc.selectRelationshipPredefined(element.replaceAll(" ", ""), null);
	}
	
	public void gmftoolInjection(String element){
		pxGT.createCreationTool(element, "Relationships", pxGT.createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
	}
	
	public void gmfgraphInjection(String element){
		pxGG.createDescriptorsLinkPolyline(element);
		pxGG.createDescriptorsLinkLabel(element);
	}

	public void gmfmapInjection(String element){
		if (cim.strDecomSource==null && cim.strDecomTarget==null) {
			pxGM.createLinks(element, "Compartment/taskdecompositionlink", "TaskDecompositionLink", null, null, null,
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "TaskDecompositionLink", "TaskDecompositionLink/source",
					"TaskDecompositionLink/target", false, "self <> oppositeEnd", null);
		}else if (cim.strDecomConstraint.equals("") && (cim.strDecomSource!=null && cim.strDecomTarget!=null)) {
			pxGM.createLinks(element, "Compartment/taskdecompositionlink", "TaskDecompositionLink", null, null, null,
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "TaskDecompositionLink", "TaskDecompositionLink/source",
					"TaskDecompositionLink/target", false, cim.strDecomSource.toString(), cim.strDecomTarget.toString());
		}else{
			pxGM.createLinks(element, "Compartment/taskdecompositionlink", "TaskDecompositionLink", cim.strDecomConstraint.toString(), null, null,
					pxGT.getToolGroup("Relationships"), cim.indexEspecializationRelationship, "TaskDecompositionLink", "TaskDecompositionLink/source",
					"TaskDecompositionLink/target", false, cim.strDecomSource.toString(), cim.strDecomTarget.toString());
		}
		pxGM.resetAll();
	}
	public void setFlagIndex(){
		cim.setFlagIndexRelationship(true);
	}
}
