package istar_pl.actions;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.UIManager;

import beans.coreelements.Actor;
import beans.coreelements.ActorLinkCovers;
import beans.coreelements.ActorLinkINS;
import beans.coreelements.ActorLinkISA;
import beans.coreelements.ActorLinkIsPartOf;
import beans.coreelements.ActorLinkOccupies;
import beans.coreelements.ActorLinkPlays;
import beans.coreelements.Agent;
import beans.coreelements.ContributionLink;
import beans.coreelements.ContributionLinkAnd;
import beans.coreelements.ContributionLinkBreak;
import beans.coreelements.ContributionLinkHelp;
import beans.coreelements.ContributionLinkHurt;
import beans.coreelements.ContributionLinkMake;
import beans.coreelements.ContributionLinkOr;
import beans.coreelements.ContributionLinkSomeMinus;
import beans.coreelements.ContributionLinkSomePlus;
import beans.coreelements.ContributionLinkUnk;
import beans.coreelements.DependencyLinkCommited;
import beans.coreelements.DependencyLinkCritical;
import beans.coreelements.DependencyLinkOpen;
import beans.coreelements.Element;
import beans.coreelements.Goal;
import beans.coreelements.Link;
import beans.coreelements.LinkWithEcore;
import beans.coreelements.LinkWithFlag;
import beans.coreelements.MeansEndLink;
import beans.coreelements.Compartment;
import beans.coreelements.Position;
import beans.coreelements.Resource;
import beans.coreelements.Role;
import beans.coreelements.Softgoal;
import beans.coreelements.Task;
import beans.coreelements.TaskDecompositionLink;

import Injection.MappingIstarConfig;
import Injection.ParserXML_GMFGraph;
import Injection.ParserXML_GMFMap;
import Injection.ParserXML_GMFTool;
import Injection.ParserXML_Metamodel;

public class ConfigIstarMetamodel extends JFrame implements ActionListener{

	private static ConfigIstarMetamodel instance = null;

	private JPanel pnCenter, pnAddActor, pnAddElement, pnAddRelationship, pnSouthButton,pnAddAux;
	private JButton jbCreateFile, jbCancel,/* TODO vercom josias isto jbOCL, */jbNewConstructor, jbConstContri;
	private ArrayList<JCheckBox> CompartmentsCheckBox, MMCheckBox, ContributionCheck, DependencyCheck;
	private JCheckBox cbActor, cbAgent, cbRole, cbPosition, cbGoal, cbTask, cbResource, cbSoftgoal;
	private JCheckBox cbMeans, cbDecom;
	private JCheckBox cbMake, cbBreak, cbUnk, cbSomeplus, cbSomeminus, cbAnd, cbOr, cbHelp, cbHurt;
	private JCheckBox cbCommited, cbOpen, cbCritical;
	private JCheckBox cbIsa, cbCovers, cbIspartof, cbOccupies, cbPlays, cbIns; 

	private ArrayList<JLabel> jlL;

	private JLabel lbName;
	private JTextField tfName;

	private Container tela;

	private JFileChooser fc;

	public static ArrayList<String> contributions;
	public static ArrayList<String> Dependencys;
	public static ArrayList<String> associations;
	public static ArrayList<No<String>> nodes;

	private int indexAux = 0;
	public static int indexEspecializationCompartment = 0;
	public static int indexEspecializationActorLink = 0;
	public static int indexEspecializationDependencyElements = 0;
	public static int indexEspecializationRelationship = 0;
	public static int indexEspecializationContribution = 0;

	private static boolean flagIndexCompartment = false;
	private static boolean flagIndexActorLink = false;
	private static boolean flagIndexDependencyElements = false;
	private static boolean flagIndexRelationship = false;
	private static boolean flagIndexContribution = false;

	private static boolean runMapping = false;

	private ParserXML_Metamodel pxMM;
	private ParserXML_GMFTool pxGT;
	private ParserXML_GMFGraph pxGG;
	private ParserXML_GMFMap pxGM;
	private MappingIstarConfig mc;

	private ArrayList<Relacoes<No>> relacoesContri;
	private ArrayList<Relacoes<No>> relacoesMeans;
	private ArrayList<Relacoes<No>> relacoesDecom;
	private ArrayList<Relacoes<No>> relacoesDepen;
	private ArrayList<Relacoes<No>> relacoesNewLink;

	private JButton jbConstDep;
	private JButton jbConstMeans;
	private JButton jbConstDecom;

	public static String strDepenSource;
	public static String strDepenTarget;
	public static String strDepenConstraint;
	public static String strDecomSource;
	public static String strDecomTarget;
	public static String strDecomConstraint;
	public static String strMeansSource;
	public static String strMeansTarget;
	public static String strMeansConstraint;
	public static String strContriSource;
	public static String strContriTarget;
	public static String strContriConstraint;

	/**
	 * Classe principal onde o usurio pode fazer a configurao da herana do i* e criao automatica dos modelos GMF.
	 */
	private ConfigIstarMetamodel(){
		super("Configure a new metamodel");
		initRelacoes();

		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,
					"No foi possvel carregar o \"Skin\" padro. Definindo o padro original.", "Erro",
					JOptionPane.ERROR_MESSAGE);
		}

		tela = getContentPane();
		tela.setLayout(new BorderLayout());

		createImages();
		createJCheckBox();
		createJLabels();
		createJButtons();
		createJPanes();

		tela.add(BorderLayout.NORTH, pnAddAux);
		tela.add(BorderLayout.SOUTH, pnCenter);

		setSize(570,485);
		setVisible(true);
		setResizable(false);
		setLocationRelativeTo(null);

		fc = new JFileChooser();

		for(JCheckBox jcb : CompartmentsCheckBox)
			if (jcb.isSelected()) 
				addItens(new No<String>(jcb.getText(), NODE_TYPES.COMPARTMENT));
		for(JCheckBox jcb : MMCheckBox)
			if (jcb.isSelected())
				addItens(new No<String>(jcb.getText(), NODE_TYPES.ELEMENT_MC));

		pxMM = new ParserXML_Metamodel();
		pxMM.createAlias();
		pxMM.createCore();

		pxGT = new ParserXML_GMFTool();
		pxGT.createAlias();

		pxGG = new ParserXML_GMFGraph();
		pxGG.createAlias();

		pxGM = new ParserXML_GMFMap();
		pxGM.createAlias();

		mc = new MappingIstarConfig();
	}

	private void initRelacoes() {
		relacoesContri = new ArrayList<Relacoes<No>>();
		relacoesMeans = new ArrayList<Relacoes<No>>();
		relacoesDecom = new ArrayList<Relacoes<No>>();
		relacoesDepen = new ArrayList<Relacoes<No>>();
		relacoesNewLink = new ArrayList<Relacoes<No>>();
		contributions = new ArrayList<String>();
		Dependencys = new ArrayList<String>();
		associations = new ArrayList<String>();
		nodes = new ArrayList<No<String>>();
		CompartmentsCheckBox = new ArrayList<JCheckBox>();
		MMCheckBox = new ArrayList<JCheckBox>();
	}

	/**
	 * Esta classe  um singleton.
	 */
	public static ConfigIstarMetamodel getInstance(){
		if (instance==null)
			return instance = new ConfigIstarMetamodel();
		return instance;
	}

	/**
	 * Cria as imagens itulizadas na tela.
	 */
	private ArrayList<ImageIcon> createImages(){
		ArrayList<ImageIcon> imArray = new ArrayList<ImageIcon>();
		imArray.add(new ImageIcon("res/actor.png"));
		imArray.add(new ImageIcon("res/agent.png"));
		imArray.add(new ImageIcon("res/role.png"));
		imArray.add(new ImageIcon("res/position.png"));
		imArray.add(new ImageIcon("res/goal.png"));
		imArray.add(new ImageIcon("res/task.png"));
		imArray.add(new ImageIcon("res/resource.png"));
		imArray.add(new ImageIcon("res/soft.png"));
		return imArray;
	}

	/**
	 * Cria todos os rotulos utilizados na tela.
	 */
	private void createJLabels(){
		jlL = new ArrayList<JLabel>();
		for(ImageIcon i : createImages())
			jlL.add(new JLabel(i));
		lbName = new JLabel("File Name:");
		tfName = new JTextField();
		tfName.setPreferredSize(new Dimension(330,20));
	}

	private JButton createJButton(String name, int x, int y){
		JButton retorno = new JButton(name);
		retorno.addActionListener(this);
		retorno.setPreferredSize(new Dimension(x, y));
		return retorno;
	}
	private JButton createJButton(String name){
		JButton retorno = new JButton(name);
		retorno.addActionListener(this);
		return retorno;
	}

	/**
	 * Cria todos os botoes utilizados na tela.
	 */
	private void createJButtons(){
		jbCreateFile = createJButton("Create Files");
		jbCancel = createJButton("Cancel");
		//TODO ver com josias isto jbOCL = createJButton("Define Constraints");

		jbNewConstructor = createJButton("Create a new Modeling Element",350,30);
		jbConstMeans = createJButton("Constraints ME",110,25);
		jbConstDecom = createJButton("Constraints DT",110,25);
		jbConstContri = createJButton("Constraints CL",110, 25);
		jbConstDep = createJButton("Constraints DL",110, 25);
	}

	private JCheckBox createJCheckBoxWithActionListener(String name){
		JCheckBox retorno = new JCheckBox(name);
		retorno.setSelected(true);
		retorno.addActionListener(this);
		return retorno;
	}

	private JCheckBox createJCheckBox(String name){
		JCheckBox retorno = new JCheckBox(name);
		retorno.setSelected(true);
		return retorno;
	}

	/**
	 * Cria todos os checkbox utilizados na tela.
	 */
	public void createJCheckBox(){
		cbActor = createJCheckBoxWithActionListener("Actor");
		CompartmentsCheckBox.add(cbActor);
		cbAgent = createJCheckBoxWithActionListener("Agent");
		CompartmentsCheckBox.add(cbAgent);
		cbRole = createJCheckBoxWithActionListener("Role");
		CompartmentsCheckBox.add(cbRole);
		cbPosition = createJCheckBoxWithActionListener("Position");
		CompartmentsCheckBox.add(cbPosition);

		cbGoal = createJCheckBoxWithActionListener("Goal");
		MMCheckBox.add(cbGoal);
		cbTask = createJCheckBoxWithActionListener("Task");
		MMCheckBox.add(cbTask);
		cbResource = createJCheckBoxWithActionListener("Resource");
		MMCheckBox.add(cbResource);
		cbSoftgoal = createJCheckBoxWithActionListener("Softgoal");
		MMCheckBox.add(cbSoftgoal);

		ContributionCheck = new ArrayList<JCheckBox>();

		cbMake = createJCheckBox("Make");
		ContributionCheck.add(cbMake);
		cbBreak = createJCheckBox("Break");
		ContributionCheck.add(cbBreak);
		cbUnk = createJCheckBox("Unknown");
		ContributionCheck.add(cbUnk);
		cbSomeplus = createJCheckBox("Some+");
		ContributionCheck.add(cbSomeplus);
		cbSomeminus = createJCheckBox("Some-");
		ContributionCheck.add(cbSomeminus);
		cbAnd = createJCheckBox("And");
		ContributionCheck.add(cbAnd);
		cbOr = createJCheckBox("Or");
		ContributionCheck.add(cbOr);
		cbHelp = createJCheckBox("Help");
		ContributionCheck.add(cbHelp);
		cbHurt = createJCheckBox("Hurt");
		ContributionCheck.add(cbHurt);

		cbMeans = createJCheckBoxWithActionListener("MeansEndLink");
		cbDecom = createJCheckBoxWithActionListener("TaskDecompositionLink");

		DependencyCheck = new ArrayList<JCheckBox>();
		cbCommited = createJCheckBox("Commited");
		DependencyCheck.add(cbCommited);
		cbOpen = createJCheckBox("Open");
		DependencyCheck.add(cbOpen);
		cbCritical = createJCheckBox("Critical");
		DependencyCheck.add(cbCritical);

		cbIsa = createJCheckBoxWithActionListener("ISA");
		cbCovers = createJCheckBoxWithActionListener("Covers");
		cbIspartof = createJCheckBoxWithActionListener("IsPartOf");
		cbOccupies = createJCheckBoxWithActionListener("Occupies");
		cbPlays = createJCheckBoxWithActionListener("Plays");
		cbIns = createJCheckBoxWithActionListener("INS");

	}

	/**
	 * Cria todos os paineis e estrutura da tela.
	 */
	public void createJPanes(){
		pnAddActor = new JPanel(new FlowLayout(FlowLayout.CENTER));
		pnAddActor.setBorder(javax.swing.BorderFactory.createTitledBorder("Add Actors"));
		for(JCheckBox jcb : CompartmentsCheckBox){
			pnAddActor.add(jcb);
			pnAddActor.add(jlL.get(CompartmentsCheckBox.indexOf(jcb)));
		}

		pnAddElement = new JPanel();
		pnAddElement.setBorder(javax.swing.BorderFactory.createTitledBorder("Add Elements"));
		for(JCheckBox jcb : MMCheckBox){
			pnAddElement.add(jcb);
			pnAddElement.add(jlL.get(MMCheckBox.indexOf(jcb)+4));
		}

		pnAddAux = new JPanel(new BorderLayout());
		pnAddAux.add(BorderLayout.NORTH, pnAddActor);
		pnAddAux.add(BorderLayout.CENTER, pnAddElement);

		pnAddRelationship = new JPanel(new BorderLayout());
		pnAddRelationship.setBorder(javax.swing.BorderFactory.createTitledBorder("Add Relationships"));

		JPanel pnmeansANDdecom = new JPanel(new GridLayout(2,0));
		pnmeansANDdecom.setBorder(javax.swing.BorderFactory.createTitledBorder("Relationship"));
		pnmeansANDdecom.add(cbMeans);
		pnmeansANDdecom.add(cbDecom);

		JPanel pnContri = new JPanel(new GridLayout(5,1));
		pnContri.setBorder(javax.swing.BorderFactory.createTitledBorder("Contribution Link"));
		pnContri.add(cbMake);
		pnContri.add(cbBreak);
		pnContri.add(cbSomeminus);
		pnContri.add(cbSomeplus);
		pnContri.add(cbAnd);
		pnContri.add(cbOr);
		pnContri.add(cbHelp);
		pnContri.add(cbHurt);
		pnContri.add(cbUnk);
		pnContri.add(jbConstContri);

		JPanel pnDepen = new JPanel(new GridLayout(4,0));
		pnDepen.setBorder(javax.swing.BorderFactory.createTitledBorder("Dependency Link"));
		pnDepen.add(cbCommited);
		pnDepen.add(cbOpen);
		pnDepen.add(cbCritical);

		JPanel pnAssoci = new JPanel(new GridLayout(3,2));
		pnAssoci.setBorder(javax.swing.BorderFactory.createTitledBorder("Actor Link"));
		pnAssoci.add(cbIsa);
		pnAssoci.add(cbCovers);
		pnAssoci.add(cbIspartof);
		pnAssoci.add(cbOccupies);
		pnAssoci.add(cbPlays);
		pnAssoci.add(cbIns);

		JPanel aux01 = new JPanel(new BorderLayout());
		JPanel aux02 = new JPanel(new BorderLayout());

		JPanel aux03 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		aux03.add(jbConstMeans);
		aux03.add(new JLabel("         "));
		aux03.add(jbConstContri);
		aux03.add(new JLabel("     "));
		aux03.add(jbConstDep);

		JPanel aux04 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		aux04.add(jbConstDecom);

		JPanel aux05 = new JPanel(new FlowLayout(FlowLayout.CENTER));
		aux05.add(new JLabel("                           "));
		aux05.add(jbNewConstructor);
		aux05.add(new JLabel("                           "));

		aux01.add(BorderLayout.WEST, pnmeansANDdecom);
		aux01.add(BorderLayout.CENTER, pnContri);
		aux02.add(BorderLayout.CENTER, pnDepen);
		aux02.add(BorderLayout.EAST, pnAssoci);

		JPanel pnOCL = new JPanel(new BorderLayout());
		pnOCL.add(BorderLayout.NORTH, aux03);
		pnOCL.add(BorderLayout.CENTER, aux04);
		pnOCL.add(BorderLayout.SOUTH, aux05);

		pnAddRelationship.add(BorderLayout.WEST, aux01);
		pnAddRelationship.add(BorderLayout.CENTER, aux02);
		pnAddRelationship.add(BorderLayout.SOUTH, pnOCL);

		pnSouthButton = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		pnSouthButton.add(lbName);
		pnSouthButton.add(tfName);
		pnSouthButton.add(jbCreateFile);
		pnSouthButton.add(jbCancel);

		pnCenter = new JPanel(new BorderLayout());
		pnCenter.add(BorderLayout.CENTER, pnAddRelationship);
		pnCenter.add(BorderLayout.SOUTH, pnSouthButton);
	}

	/**
	 * Metodo importante responsavel pela gerao de codigo XML de acordo com a configurao da tela principal
	 */
	public void mapping(){

		if (associations!=null)
			associations.removeAll(associations);
		if (Dependencys!=null)
			Dependencys.removeAll(associations);
		if (contributions!=null)
			contributions.removeAll(associations);

		if (cbActor.isSelected())
			xmlGenCompartment(new Actor(pxMM, pxGT, pxGG, pxGM, mc, this),cbActor);
		if (cbAgent.isSelected())
			xmlGenCompartment(new Agent(pxMM, pxGT, pxGG, pxGM, mc, this),cbAgent);
		if (cbRole.isSelected())
			xmlGenCompartment(new Role(pxMM, pxGT, pxGG, pxGM, mc, this),cbRole);
		if (cbPosition.isSelected())
			xmlGenCompartment(new Position(pxMM, pxGT, pxGG, pxGM, mc, this),cbPosition);

		//Elementos Intencionais
		if (cbGoal.isSelected() || cbTask.isSelected() || cbResource.isSelected() || cbSoftgoal.isSelected()) {
			indexAux+=1;
			int indexElement = indexAux;
			if (cbGoal.isSelected())
				xmlGenElement(new Goal(pxMM, pxGT, pxGG, pxGM, mc, this),cbGoal);
			if (cbTask.isSelected())
				xmlGenElement(new Task(pxMM, pxGT, pxGG, pxGM, mc, this),cbTask);
			if (cbResource.isSelected())
				xmlGenElement(new Resource(pxMM, pxGT, pxGG, pxGM, mc, this),cbResource);
			if (cbSoftgoal.isSelected())
				xmlGenElement(new Softgoal(pxMM, pxGT, pxGG, pxGM, mc, this),cbSoftgoal);
		}

		//Actors Link (Actors Association)
		if (cbIsa.isSelected() || cbCovers.isSelected() || cbIspartof.isSelected()
				|| cbOccupies.isSelected() || cbPlays.isSelected() || cbIns.isSelected()) {
			indexAux+=1;
			if (cbIsa.isSelected())
				genXMLLink(new ActorLinkISA(pxMM, pxGT, pxGG, pxGM, mc, this),cbIsa);
			if (cbCovers.isSelected())
				genXMLLink(new ActorLinkCovers(pxMM, pxGT, pxGG, pxGM, mc, this),cbCovers);
			if (cbIspartof.isSelected())
				genXMLLink(new ActorLinkIsPartOf(pxMM, pxGT, pxGG, pxGM, mc, this),cbIspartof);
			if (cbOccupies.isSelected())
				genXMLLink(new ActorLinkOccupies(pxMM, pxGT, pxGG, pxGM, mc, this),cbOccupies);
			if (cbPlays.isSelected())
				genXMLLink(new ActorLinkPlays(pxMM, pxGT, pxGG, pxGM, mc, this),cbPlays);
			if (cbIns.isSelected())
				genXMLLink(new ActorLinkINS(pxMM, pxGT, pxGG, pxGM, mc, this),cbIns);
			mc.selectRelationshipPredefined("ActorLink", associations);
		}

		//Relationships
		if (cbCommited.isSelected() || cbOpen.isSelected() || cbCritical.isSelected()) {
			int indexRelationship = indexAux;
			if (cbCommited.isSelected())
				genXMLLink(new DependencyLinkCommited(pxMM, pxGT, pxGG, pxGM, mc, this),cbCommited);
			if (cbOpen.isSelected())
				genXMLLink(new DependencyLinkOpen(pxMM, pxGT, pxGG, pxGM, mc, this),cbOpen);
			if (cbCritical.isSelected())
				genXMLLink(new DependencyLinkCritical(pxMM, pxGT, pxGG, pxGM, mc, this),cbCritical);
			mc.selectRelationshipPredefined("DependencyLink", Dependencys);

			if (cbMeans.isSelected())
				genXMLLink(new MeansEndLink(pxMM, pxGT, pxGG, pxGM, mc, this),cbMeans);
			//Task Decom
			if (cbDecom.isSelected())
				genXMLLink(new TaskDecompositionLink(pxMM, pxGT, pxGG, pxGM, mc, this),cbDecom);
		}

		//Contribution
		if (cbMake.isSelected() || cbBreak.isSelected() || cbUnk.isSelected()
				|| cbSomeplus.isSelected() || cbSomeminus.isSelected() || cbAnd.isSelected()
				|| cbOr.isSelected() || cbHelp.isSelected() || cbHurt.isSelected()) {
			indexAux+=1;
			int indexContribution = indexAux;
			pxGT.clearCreationTool();
			if (cbMake.isSelected())
				genXMLLink(new ContributionLinkMake(pxMM, pxGT, pxGG, pxGM, mc, this),cbMake);
			if (cbBreak.isSelected())
				genXMLLink(new ContributionLinkBreak(pxMM, pxGT, pxGG, pxGM, mc, this),cbBreak);
			if (cbUnk.isSelected())
				genXMLLink(new ContributionLinkUnk(pxMM, pxGT, pxGG, pxGM, mc, this),cbUnk);
			if (cbSomeplus.isSelected())
				contributionLinkBodyMethod(new ContributionLinkSomePlus(pxMM, pxGT, pxGG, pxGM, mc, this));
			if (cbSomeminus.isSelected())
				contributionLinkBodyMethod(new ContributionLinkSomeMinus(pxMM, pxGT, pxGG, pxGM, mc, this));
			if (cbAnd.isSelected())
				genXMLLink(new ContributionLinkAnd(pxMM, pxGT, pxGG, pxGM, mc, this),cbAnd);
			if (cbOr.isSelected())
				genXMLLink(new ContributionLinkOr(pxMM, pxGT, pxGG, pxGM, mc, this),cbOr);
			if (cbHelp.isSelected())
				genXMLLink(new ContributionLinkHelp(pxMM, pxGT, pxGG, pxGM, mc, this),cbHelp);
			if (cbHurt.isSelected())
				genXMLLink(new ContributionLinkHurt(pxMM, pxGT, pxGG, pxGM, mc, this),cbHurt);
			mc.selectRelationshipPredefined("ContributionLink", contributions);
		}

		//gmftool
		pxGT.createPalette(tfName.getText());
		//gmfgraph
		pxGG.createFigures(pxGG.getDescriptors());
		//gmfmap
		pxGM.createDiagram(tfName.getText());

	}

	private void contributionLinkBodyMethod(ContributionLink link) {
		link.gmftoolInjection();
		link.gmfgraphInjection();
		link.gmfmapInjection(tfName.getText());
	}

	private void genXMLLink(LinkWithEcore link,JCheckBox jcb) {
		link.ecoreInjection(jcb.getText());
		link.gmftoolInjection(jcb.getText());
		link.gmfgraphInjection(jcb.getText());
		link.gmfmapInjection(tfName.getText());
		link.setFlagIndex();
	}

	private void genXMLLink(LinkWithFlag link,JCheckBox jcb) {
		link.gmftoolInjection(jcb.getText());
		link.gmfgraphInjection(jcb.getText());
		link.gmfmapInjection(tfName.getText());
		link.setFlagIndex();
	}

	private void genXMLLink(Link link,JCheckBox jcb) {
		link.gmftoolInjection(jcb.getText());
		link.gmfgraphInjection(jcb.getText());
		link.gmfmapInjection(tfName.getText());
	}

	private void xmlGenCompartment(Compartment compartment, JCheckBox jcb) {
		compartment.ecoreInjection(jcb.getText());
		compartment.gmftoolInjection(jcb.getText());
		compartment.gmfgraphInjection(jcb.getText());
		compartment.gmfmapInjection(tfName.getText());
		compartment.setFlagIndex();
	}

	private void xmlGenElement(Element element, JCheckBox jcb) {
		element.ecoreInjection(jcb.getText());
		element.gmftoolInjection(jcb.getText());
		element.gmfgraphInjection(jcb.getText());
		element.gmfmapInjection(tfName.getText());
		element.setFlagIndex();
	}

	/**
	 * Metodo para criao do local onde os arquivos sero salvos
	 */
	public void createFile(){
		if (tfName.getText().equals("")) {
			JOptionPane jp = new JOptionPane();
			jp.showMessageDialog(this, "Please provide a file name!", "Warning!", JOptionPane.INFORMATION_MESSAGE);
		}else if (fc.showSaveDialog(ConfigIstarMetamodel.this) == JFileChooser.APPROVE_OPTION){
			File f = fc.getSelectedFile();
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			pxMM.createXML();
			pxMM.createFile(f.getPath().substring(0, f.getPath().lastIndexOf('\\')), tfName.getText());

			pxGT.createXML();
			pxGT.createFileGMFTool(f.getPath().substring(0, f.getPath().lastIndexOf('\\')), tfName.getText());

			pxGG.createXML();
			pxGG.createFileGMFGraph(f.getPath().substring(0, f.getPath().lastIndexOf('\\')), tfName.getText());

			pxGM.createXML();
			pxGM.createFileGMFGraph(f.getPath().substring(0, f.getPath().lastIndexOf('\\')), tfName.getText());

			setVisible(false);
			dispose();
		}
	}

	/**
	 * Metodo que captura os nodes (atores e elementos) pre-selecionados para composio das telas de restrio
	 */
	public void addItens(No item){
		boolean existe = false;
		for (int i = 0; i < nodes.size(); i++)
			if (nodes.get(i).equals(item.toString()))
				existe = true;
		if (!existe)
			nodes.add(item);
	}

	private void refactoryActionPerformed1(boolean Selected,String stype,NODE_TYPES type){
		if (Selected)
			addItens(new No<String>(stype, type));
		else
			for (int i = 0; i < nodes.size(); i++)
				if (nodes.get(i).equals(stype))
					nodes.remove(i);
	}

	/**
	 * Metodo de tratamento de eventos
	 */
	public void actionPerformed(ActionEvent e) {

		//Tratamento para que o nodes exista na tela de restries
		if (e.getSource().equals(cbActor)) {
			refactoryActionPerformed1(cbActor.isSelected(),"Actor",NODE_TYPES.COMPARTMENT);
			//Tratamento para que o nodes exista na tela de restries
		}else if (e.getSource().equals(cbAgent)) {
			refactoryActionPerformed1(cbAgent.isSelected(),"Agent",NODE_TYPES.COMPARTMENT);
			//Tratamento para que o nodes exista na tela de restries
		}else if (e.getSource().equals(cbPosition)) {
			refactoryActionPerformed1(cbPosition.isSelected(),"Position",NODE_TYPES.COMPARTMENT);
			//Tratamento para que o nodes exista na tela de restries
		}else if (e.getSource().equals(cbRole)) {
			refactoryActionPerformed1(cbRole.isSelected(),"Role",NODE_TYPES.COMPARTMENT);
			//Tratamento para que o nodes exista na tela de restries
		}else if (e.getSource().equals(cbGoal)) {
			refactoryActionPerformed1(cbGoal.isSelected(),"Goal",NODE_TYPES.ELEMENT_MC);
		}
		//Tratamento para que o nodes exista na tela de restries
		else if (e.getSource().equals(cbTask)) {
			refactoryActionPerformed1(cbTask.isSelected(),"Task",NODE_TYPES.ELEMENT_MC);
			//Tratamento para que o nodes exista na tela de restries
		}else if (e.getSource().equals(cbResource)) {
			refactoryActionPerformed1(cbResource.isSelected(),"Resource",NODE_TYPES.ELEMENT_MC);
			//Tratamento para que o nodes exista na tela de restries
		}else if (e.getSource().equals(cbSoftgoal)) {
			refactoryActionPerformed1(cbSoftgoal.isSelected(),"Softgoal",NODE_TYPES.ELEMENT_MC);
		}

		//Tratamento para criao da tela de restries quando o relacionamento Contribuio for selecionado
		else if (e.getSource().equals(jbConstContri)) {
			new Constraints<String>("Contribution Link", getMinor_Nodes(), getMinor_Nodes(), relacoesContri, this);
			//Tratamento para criao da tela de restries quando o relacionamento MeansEndLink for selecionado
		}else if (e.getSource().equals(jbConstMeans)) {
			if (cbMeans.isSelected()) {
				new Constraints<String>(cbMeans.getLabel(), getMinor_Nodes(), getMinor_Nodes(), relacoesMeans, this);
			}else{
				JOptionPane jp = new JOptionPane();
				jp.showMessageDialog(null, "Means-End Relationship is not selected");
			}
			//Tratamento para criao da tela de restries quando o relacionamento Decomposio for selecionado
		}else if (e.getSource().equals(jbConstDecom)) {
			if (cbDecom.isSelected()) {
				new Constraints<String>(cbDecom.getLabel(), getMinor_Nodes(), getMinor_Nodes(), relacoesDecom, this);
			}else{
				JOptionPane jp = new JOptionPane();
				jp.showMessageDialog(null, "Decomposition Task Relationship is not selected");
			}
			//Tratamento para criao da tela de restries quando o relacionamento Dependencia for selecionado
		}else if (e.getSource().equals(jbConstDep)) {
			new Constraints<String>("Dependency Link", nodes, nodes, relacoesDepen, this);
			//Desmarcaes de checks para prover semantica de utilizao dos relacionamentos com nodes
		}else if (e.getSource().equals(cbPosition)) {
			cbCovers.setSelected(cbPosition.isSelected());
			cbOccupies.setSelected(cbPosition.isSelected());
		}else if (e.getSource().equals(cbRole)) {
			cbCovers.setSelected(cbRole.isSelected());
			cbPlays.setSelected(cbRole.isSelected());
		}else if (e.getSource().equals(cbAgent)) {
			cbOccupies.setSelected(cbAgent.isSelected());
			cbPlays.setSelected(cbAgent.isSelected());
		}
		//Tratamento do evento para criao dos modelos GMF
		else if (e.getSource().equals(jbCreateFile)) {
			mapping();
			createFile();
		}else if (e.getSource().equals(jbCancel)) {
			setVisible(false);
			dispose();
			//Tratamento do evento para criao de novos elementos de modelagem
		}else if (e.getSource().equals(jbNewConstructor)) {
			JOptionPane jp = new JOptionPane();
			int n = jp.showConfirmDialog(this, "Have you configured the i* base?", "Please confirm", JOptionPane.YES_NO_OPTION);
			if (n == JOptionPane.YES_OPTION) {
				ConfigNewConstructor cc = new ConfigNewConstructor(this);
				cc.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
			}//TODO else if (n == JOptionPane.NO_OPTION) {}
		}
	}

	private ArrayList<No<String>> getMinor_Nodes() {
		ArrayList<No<String>> minor_nodes = new ArrayList<No<String>>();
		for(No n : nodes)
			if(n.n != NODE_TYPES.COMPARTMENT)
				minor_nodes.add(n);
		return minor_nodes;
	}

	//Getters and Setters
	public ArrayList<String> getContributions() {
		return contributions;
	}

	public ArrayList<String> getOCL(){
		ArrayList<String> resultado = new ArrayList<String>();
		for(JCheckBox jcb : ContributionCheck){
			if(jcb.isSelected()){
				resultado.add(getSelfOCLCONTRIBUTION(jcb.getText().toUpperCase(),strContriConstraint));
				resultado.add(getSelfOCLCONTRIBUTION(jcb.getText().toUpperCase(),strMeansConstraint));
				resultado.add(getSelfOCLCONTRIBUTION(jcb.getText().toUpperCase(),strDecomConstraint));
				resultado.add(getSelfOCLCONTRIBUTION(jcb.getText().toUpperCase(),strDepenConstraint));
			}
		}
		for(JCheckBox jcb : DependencyCheck){
			if(jcb.isSelected()){	
				resultado.add(getSelfOCLDEPENDENCY(jcb.getText().toUpperCase(),strContriConstraint));
				resultado.add(getSelfOCLDEPENDENCY(jcb.getText().toUpperCase(),strMeansConstraint));
				resultado.add(getSelfOCLDEPENDENCY(jcb.getText().toUpperCase(),strDecomConstraint));
				resultado.add(getSelfOCLDEPENDENCY(jcb.getText().toUpperCase(),strDepenConstraint));
			}

		}
		return resultado;
	}
	
	private String getSelfOCLDEPENDENCY(String str1,String str2){
		return "self.oclAsType(DependencyLink).type=DependencyLinkType::"+str1+" and "+str2;
	}
	
	private String getSelfOCLCONTRIBUTION(String str1,String str2){
		return "self.oclAsType(ContributionLink).type=ContributionLinkType::"+str1+" and "+str2;
	}

	public void setContributions(ArrayList<String> contributions) {
		this.contributions = contributions;
	}

	public ArrayList<String> getDependencys() {
		return Dependencys;
	}

	public void setDependencys(ArrayList<String> Dependencys) {
		this.Dependencys = Dependencys;
	}

	public ArrayList<String> getAssociations() {
		return associations;
	}

	public void setAssociations(ArrayList<String> associations) {
		this.associations = associations;
	}

	public JTextField getTfName() {
		return tfName;
	}

	public void setTfName(JTextField tfName) {
		this.tfName = tfName;
	}

	public ParserXML_Metamodel getPxMM() {
		return pxMM;
	}

	public static int getIndexEspecializationCompartment() {
		return indexEspecializationCompartment;
	}

	public static void setIndexEspecializationCompartment(int indexEspecializationCompartment) {
		ConfigIstarMetamodel.indexEspecializationCompartment = indexEspecializationCompartment;
	}

	public static int getIndexEspecializationActorLink() {
		return indexEspecializationActorLink;
	}

	public static void setIndexEspecializationActorLink(int indexEspecializationActorLink) {
		ConfigIstarMetamodel.indexEspecializationActorLink = indexEspecializationActorLink;
	}

	public static int getIndexEspecializationDependencyElements() {
		return indexEspecializationDependencyElements;
	}

	public static void setIndexEspecializationDependencyElements(int indexEspecializationDependencyElements) {
		ConfigIstarMetamodel.indexEspecializationDependencyElements = indexEspecializationDependencyElements;
	}

	public static int getIndexEspecializationRelationship() {
		return indexEspecializationRelationship;
	}

	public static void setIndexEspecializationRelationship(int indexEspecializationRelationship) {
		ConfigIstarMetamodel.indexEspecializationRelationship = indexEspecializationRelationship;
	}

	public static int getIndexEspecializationContribution() {
		return indexEspecializationContribution;
	}

	public static void setIndexEspecializationContribution(
			int indexEspecializationContribution) {
		ConfigIstarMetamodel.indexEspecializationContribution = indexEspecializationContribution;
	}

	public void setPxMM(ParserXML_Metamodel pxMM) {
		this.pxMM = pxMM;
	}

	public ParserXML_GMFTool getPxGT() {
		return pxGT;
	}

	public void setPxGT(ParserXML_GMFTool pxGT) {
		this.pxGT = pxGT;
	}

	public ParserXML_GMFGraph getPxGG() {
		return pxGG;
	}

	public void setPxGG(ParserXML_GMFGraph pxGG) {
		this.pxGG = pxGG;
	}

	public ParserXML_GMFMap getPxGM() {
		return pxGM;
	}

	public void setPxGM(ParserXML_GMFMap pxGM) {
		this.pxGM = pxGM;
	}

	public static boolean isFlagIndexCompartment() {
		return flagIndexCompartment;
	}

	public static void setFlagIndexCompartment(boolean flagIndexCompartment) {
		ConfigIstarMetamodel.flagIndexCompartment = flagIndexCompartment;
	}

	public static boolean isFlagIndexActorLink() {
		return flagIndexActorLink;
	}

	public static void setFlagIndexActorLink(boolean flagIndexActorLink) {
		ConfigIstarMetamodel.flagIndexActorLink = flagIndexActorLink;
	}

	public static boolean isFlagIndexDependencyElements() {
		return flagIndexDependencyElements;
	}

	public static void setFlagIndexDependencyElements(boolean flagIndexDependencyElements) {
		ConfigIstarMetamodel.flagIndexDependencyElements = flagIndexDependencyElements;
	}

	public static boolean isFlagIndexRelationship() {
		return flagIndexRelationship;
	}

	public static void setFlagIndexRelationship(boolean flagIndexRelationship) {
		ConfigIstarMetamodel.flagIndexRelationship = flagIndexRelationship;
	}

	public static boolean isFlagIndexContribution() {
		return flagIndexContribution;
	}

	public static void setFlagIndexContribution(boolean flagIndexContribution) {
		ConfigIstarMetamodel.flagIndexContribution = flagIndexContribution;
	}

	public static boolean isRunMapping() {
		return runMapping;
	}

	public static void setRunMapping(boolean runMapping) {
		ConfigIstarMetamodel.runMapping = runMapping;
	}

	public ArrayList<Relacoes<No>> getRelacoesNewLink() {
		return relacoesNewLink;
	}

	public void setRelacoesNewLink(ArrayList<Relacoes<No>> relacoesNewLink) {
		this.relacoesNewLink = relacoesNewLink;
	}

	public ArrayList<No<String>> getNodes() {
		return nodes;
	}

	public void setNodes(ArrayList<No<String>> nodes) {
		this.nodes = nodes;
	}

	public String getStrDepenSource() {
		return strDepenSource;
	}

	public void setStrDepenSource(String strDepenSource) {
		this.strDepenSource = strDepenSource;
	}

	public String getStrDepenTarget() {
		return strDepenTarget;
	}

	public void setStrDepenTarget(String strDepenTarget) {
		this.strDepenTarget = strDepenTarget;
	}

	public String getStrDepenConstraint() {
		return strDepenConstraint;
	}

	public void setStrDepenConstraint(String strDepenConstraint) {
		this.strDepenConstraint = strDepenConstraint;
	}

	public String getStrDecomSource() {
		return strDecomSource;
	}

	public void setStrDecomSource(String strDecomSource) {
		this.strDecomSource = strDecomSource;
	}

	public String getStrDecomTarget() {
		return strDecomTarget;
	}

	public void setStrDecomTarget(String strDecomTarget) {
		this.strDecomTarget = strDecomTarget;
	}

	public String getStrDecomConstraint() {
		return strDecomConstraint;
	}

	public void setStrDecomConstraint(String strDecomConstraint) {
		this.strDecomConstraint = strDecomConstraint;
	}

	public String getStrMeansSource() {
		return strMeansSource;
	}

	public void setStrMeansSource(String strMeansSource) {
		this.strMeansSource = strMeansSource;
	}

	public String getStrMeansTarget() {
		return strMeansTarget;
	}

	public void setStrMeansTarget(String strMeansTarget) {
		this.strMeansTarget = strMeansTarget;
	}

	public String getStrMeansConstraint() {
		return strMeansConstraint;
	}

	public void setStrMeansConstraint(String strMeansConstraint) {
		this.strMeansConstraint = strMeansConstraint;
	}

	public String getStrContriSource() {
		return strContriSource;
	}

	public void setStrContriSource(String strContriSource) {
		this.strContriSource = strContriSource;
	}

	public String getStrContriTarget() {
		return strContriTarget;
	}

	public void setStrContriTarget(String strContriTarget) {
		this.strContriTarget = strContriTarget;
	}

	public String getStrContriConstraint() {
		return strContriConstraint;
	}

	public void setStrContriConstraint(String strContriConstraint) {
		this.strContriConstraint = strContriConstraint;
	}

	public static void main(String[] args) {
		ConfigIstarMetamodel cim = ConfigIstarMetamodel.getInstance();
		cim.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}
}
