package istar_pl.actions;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;

import javax.smartcardio.ATR;
import javax.swing.ButtonGroup;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.UIManager;

import Injection.NewConstructor;
import beans.metamodel.Attribute;
import beans.metamodel.Constructor;
import beans.metamodel.eClassifier;
import beans.metamodel.eLiteral;

public class ConfigNewConstructor extends JFrame implements ActionListener{


	//	private static ArrayList<Constructor> constructors;
	private HashSet<String> attNames;
	private ArrayList<Attribute> attributes;
	private ArrayList<eClassifier> enums;
	private static ArrayList<String> links;

	private WindowAddLiteral al;

	private JPanel jpClassification, jpConstruName, jpComposition, jpSouth, aux1, aux2, aux4, aux5, jpAttribute;
	private JPanel jpSource, jpTarget;
	private JLabel lbClass, lbName, lbComposition, lbAttri, lbAttriType, lbCard;
	private JTextField tfName, tfAttri,tfEnum;
	private JRadioButton rbCompartment, rbElement, rbLink, rbPrimitive, rbEnum, rb01, rb0n, rb1n, rb11, rbIntentionalElementYes, rbIntentionalElementNo;
	private JCheckBox cbModel, cbCompartment, cbSourceMod, cbSourceEle, cbSourceLink, cbTargetMod, cbTargetEle, cbTargetLink;
	private ButtonGroup group, group2, group3, group4;
	private JButton jbConstraint, jbOk, jbCancel, jbAddAttri, jbRemAttri;
	private JComboBox boxType;
	private JList jlAttri;
	private DefaultListModel listModel;
	private JScrollPane listScroller;
	private int index;

	private Container tela;

	private Constraints<String> newLink;

	private ConfigIstarMetamodel cim;

	private static boolean flagElementMCSemAtribute = true;
	private static boolean flagElementModelSemAtribute = true;
	private static boolean flagElementCompartmentSemAtribute = true;
	private static boolean flagCompartmentCompartmentSemAtribute = true;
	private static boolean flagCompartmentModelSemAtribute = true;
	private static boolean flagCompartmentMMSemAtribute = true;

	/**
	 * Esta classe  uma janela que  apresentada toda a estrutura de configurao de um novo elemento.
	 * @param ConfigiStarMetamodel
	 */
	public ConfigNewConstructor(ConfigIstarMetamodel cim){
		super("Configure a new element modeling");
		this.cim = cim;

		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		} catch (Exception e) {
			JOptionPane.showMessageDialog(null,
					"No foi possvel carregar o \"Skin\" padro. Definindo o padro original.", "Erro",
					JOptionPane.ERROR_MESSAGE);
		}

		tela = getContentPane();
		tela.setLayout(new BorderLayout());

		createJCheckBox();
		createJLabel();
		createJButton();
		createJComboBox();
		createJList();
		createJRadioButton();
		createJPanel();

		setSize(480,520);
		setVisible(true);
		setResizable(false);
		setLocationRelativeTo(null);

		tela.add(BorderLayout.NORTH, jpConstruName);
		tela.add(BorderLayout.CENTER, aux1);
		tela.add(BorderLayout.SOUTH, jpSouth);

		attNames = new HashSet<String>();
		attributes = new ArrayList<Attribute>();
		links = new ArrayList<String>();
		enums = new ArrayList<eClassifier>();

	}

	/**
	 * Cria todos os rotulos da tela
	 */
	public void createJLabel(){
		lbName = new JLabel("Constructor name:");

		tfName = new JTextField();
		tfName.setPreferredSize(new Dimension(200,20));

		lbClass = new JLabel("Select classification:");
		lbComposition = new JLabel("Composition:");

		lbAttri = new JLabel("Name:");
		lbAttriType = new JLabel("Select Type:");

		tfAttri = new JTextField();
		tfAttri.setPreferredSize(new Dimension(350,20));

		tfEnum= new JTextField();
		tfEnum.setPreferredSize(new Dimension(150,20));
		tfEnum.disable();

		lbCard = new JLabel("Cardinality:");

	}

	/**
	 * Cria todos os Combobox da tela
	 */
	public void createJComboBox(){
		boxType = new JComboBox();
		boxType.setPreferredSize(new Dimension(150,20));
		boxType.addItem("EString");
		boxType.addItem("EBigDecimal");
		boxType.addItem("EBigInteger");
		boxType.addItem("EBoolean");
		boxType.addItem("EBooleanObject");
		boxType.addItem("EByte");
		boxType.addItem("EByteArray");
		boxType.addItem("EByteObject");
		boxType.addItem("EChar");
		boxType.addItem("ECharacterObject");
		boxType.addItem("EDate");
		boxType.addItem("EDiagnosticChain");
		boxType.addItem("EDouble");
		boxType.addItem("EDoubleObject");
		boxType.addItem("EEList");
		boxType.addItem("EEnumerator");
		boxType.addItem("EFeatureMap");
		boxType.addItem("EFeatureMapEntry");
		boxType.addItem("EFloat");
		boxType.addItem("EFloatObject");
		boxType.addItem("EInt");
		boxType.addItem("EIntegerObject");
		boxType.addItem("EJavaObject");
		boxType.addItem("EJavaClass");
		boxType.addItem("ELong");
		boxType.addItem("ELongObject");
		boxType.addItem("EMap");
		boxType.addItem("EResource");
		boxType.addItem("EResourceSet");
		boxType.addItem("EShort");
		boxType.addItem("EShortObject");
		boxType.addItem("ETreeIterator");
	}

	/**
	 * Cria todas as Listas da tela
	 */
	public void createJList(){
		listModel = new DefaultListModel();

		jlAttri = new JList(listModel);
		jlAttri.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		jlAttri.setLayoutOrientation(JList.VERTICAL);
		jlAttri.setVisibleRowCount(-1);
		jlAttri.setPreferredSize(new Dimension(150,100));

		listScroller = new JScrollPane(jlAttri, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		listScroller.setPreferredSize(new Dimension(120,100));
	}

	/**
	 * Cria todos os Botoes da tela
	 */
	public void createJButton(){
		jbOk = createButton("Ok");
		jbCancel = createButton("Cancel");
		jbAddAttri = createButton("Add");
		jbRemAttri = createButton("Del");
		jbConstraint = createButton("Constraint New Relationship");
		jbConstraint.setEnabled(false);
	}

	private JButton createButton(String s) {
		JButton jb = new JButton(s);
		jb.addActionListener(this);
		return jb;
	}

	/**
	 * Cria todos os Checkbox da tela
	 */
	public void createJCheckBox(){
		cbModel = new JCheckBox("Model");
		cbModel.setSelected(true);
		cbModel.addActionListener(this);
		cbCompartment = new JCheckBox("Compartment");
		cbCompartment.addActionListener(this);

		cbSourceMod = new JCheckBox("Compartment");
		cbSourceEle = new JCheckBox("Element");
		cbSourceLink = new JCheckBox("Link");
		cbTargetMod = new JCheckBox("Compartment");
		cbTargetEle = new JCheckBox("Element");
		cbTargetLink = new JCheckBox("Link");
	}

	/**
	 * Cria todos os RadioButtons da tela
	 */
	public void createJRadioButton(){
		rbCompartment = new JRadioButton("Compartment");
		rbCompartment.addActionListener(this);
		rbCompartment.setSelected(true);
		rbElement = new JRadioButton("Element");
		rbElement.addActionListener(this);
		rbLink = new JRadioButton("Link");
		rbLink.addActionListener(this);

		group = new ButtonGroup();
		group.add(rbCompartment);
		group.add(rbElement);
		group.add(rbLink);

		rbPrimitive = new JRadioButton("Primitive Type   ");
		rbPrimitive.addActionListener(this);
		rbPrimitive.setSelected(true);
		rbEnum = new JRadioButton("Enumeration     ");
		rbEnum.addActionListener(this);

		group2 = new ButtonGroup();
		group2.add(rbPrimitive);
		group2.add(rbEnum);

		rb01 = new JRadioButton("0-1");
		rb01.addActionListener(this);
		rb0n = new JRadioButton("0-*");
		rb0n.addActionListener(this);
		rb0n.setSelected(true);
		rb11 = new JRadioButton("1-1");
		rb11.addActionListener(this);
		rb1n = new JRadioButton("1-*");
		rb1n.addActionListener(this);

		group3 = new ButtonGroup();
		group3.add(rb01);
		group3.add(rb0n);
		group3.add(rb11);
		group3.add(rb1n);

		rbIntentionalElementYes = new JRadioButton("Yes");
		rbIntentionalElementYes.setEnabled(false);
		rbIntentionalElementNo = new JRadioButton("No");
		rbIntentionalElementNo.setEnabled(false);

		group4 = new ButtonGroup();
		group4.add(rbIntentionalElementYes);
		group4.add(rbIntentionalElementNo);
	}

	/**
	 * Cria todos os paineis e estrutura da tela.
	 */
	public void createJPanel(){

		jpConstruName = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpConstruName.add(lbName);
		jpConstruName.add(tfName);

		jpClassification = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpClassification.setBorder(javax.swing.BorderFactory.createTitledBorder("Select Classification"));
		jpClassification.add(rbCompartment);
		jpClassification.add(rbElement);
		jpClassification.add(rbLink);

		jpComposition = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpComposition.setBorder(javax.swing.BorderFactory.createTitledBorder("Select Composition"));
		jpComposition.add(cbModel);
		jpComposition.add(cbCompartment);

		JPanel temp = new JPanel(new FlowLayout(FlowLayout.LEFT));
		temp.setBorder(javax.swing.BorderFactory.createTitledBorder("Intentional Element"));
		temp.add(rbIntentionalElementYes);
		temp.add(rbIntentionalElementNo);

		aux1 = new JPanel(new BorderLayout());

		aux2 = new JPanel(new BorderLayout());
		aux2.add(BorderLayout.WEST, jpClassification);
		aux2.add(BorderLayout.EAST, jpComposition);
		aux2.add(BorderLayout.SOUTH,temp);

		JPanel a0 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		a0.add(lbAttri);
		a0.add(tfAttri);
		a0.add(jbAddAttri);
		a0.add(jbRemAttri);

		JPanel ee = new JPanel(new FlowLayout(FlowLayout.LEFT));
		ee.add(rbPrimitive);
		ee.add(boxType);

		JPanel bb = new JPanel(new FlowLayout(FlowLayout.LEFT));
		bb.add(rbEnum);
		bb.add(tfEnum);

		JPanel hh = new JPanel(new BorderLayout());
		hh.add(BorderLayout.NORTH, ee);
		hh.add(BorderLayout.CENTER, bb);

		JPanel ss = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		ss.add(jbAddAttri);
		ss.add(jbRemAttri);

		JPanel type = new JPanel(new BorderLayout());
		type.add(BorderLayout.NORTH, lbAttriType);
		type.add(BorderLayout.CENTER,hh);
		type.add(BorderLayout.SOUTH,ss);

		JPanel a2 = new JPanel(new BorderLayout());
		a2.add(BorderLayout.CENTER, type);
		a2.add(BorderLayout.EAST, listScroller);

		jpAttribute = new JPanel(new BorderLayout());
		jpAttribute.setBorder(javax.swing.BorderFactory.createTitledBorder("Set Attribute"));
		jpAttribute.add(BorderLayout.NORTH, a0);
		jpAttribute.add(BorderLayout.CENTER, a2);

		aux1.add(BorderLayout.NORTH, aux2);
		aux1.add(BorderLayout.SOUTH, jpAttribute);

		jpSouth = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		jpSouth.add(jbOk);
		jpSouth.add(jbCancel);

		jpSource = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpSource.setBorder(javax.swing.BorderFactory.createTitledBorder("Source"));
		jpSource.add(cbSourceMod);
		jpSource.add(cbSourceEle);
		jpSource.add(cbSourceLink);

		jpTarget = new JPanel(new FlowLayout(FlowLayout.LEFT));
		jpTarget.setBorder(javax.swing.BorderFactory.createTitledBorder("Target"));
		jpTarget.add(cbTargetMod);
		jpTarget.add(cbTargetEle);
		jpTarget.add(cbTargetLink);

		JPanel jp = new JPanel(new FlowLayout(FlowLayout.CENTER));
		jp.add(lbCard);
		jp.add(rb0n);
		jp.add(rb1n);
		jp.add(rb01);
		jp.add(rb11);

		aux4 = new JPanel(new BorderLayout());
		aux4.setBorder(javax.swing.BorderFactory.createTitledBorder("Configure Link"));
		aux4.add(BorderLayout.NORTH, jp);
		aux4.add(BorderLayout.WEST, jpSource);
		aux4.add(BorderLayout.EAST, jpTarget);
		aux4.add(BorderLayout.SOUTH, jbConstraint);

		JPanel teste = new JPanel(new BorderLayout());
		//teste.add(BorderLayout.NORTH, aux3);
		teste.add(BorderLayout.SOUTH, aux4);

		aux1.add(BorderLayout.CENTER, teste);

		lbCard.setEnabled(false);
		rb01.setEnabled(false);
		rb0n.setEnabled(false);
		rb11.setEnabled(false);
		rb1n.setEnabled(false);
		cbSourceMod.setEnabled(false);
		cbSourceEle.setEnabled(false);
		cbSourceLink.setEnabled(false);
		cbTargetMod.setEnabled(false);
		cbTargetEle.setEnabled(false);
		cbTargetLink.setEnabled(false);
	}

	/**
	 * Trata os possiveis tipos de atributos que um elemento pode ter
	 */
	public String treatType(String eType){
		return (verificarTreat(eType)?
				"ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//"+eType
				:
					eType);
	}

	private boolean verificarTreat(String eType) {
		return eType.equals("EString")||eType.equals("EBigDecimal")||
				eType.equals("EBigInteger")||eType.equals("EBoolean")||
				eType.equals("EBooleanObject")||eType.equals("EByte")||
				eType.equals("EByteArray")||eType.equals("EByteObject")||
				eType.equals("EChar")||eType.equals("ECharacterObject")||
				eType.equals("EDate")||eType.equals("EDiagnosticChain")||
				eType.equals("EDouble")||eType.equals("EDoubleObject")||
				eType.equals("EEList")||eType.equals("EEnumerator")||
				eType.equals("EFeatureMap")||eType.equals("EFeatureMapEntry")||
				eType.equals("EFloat")||eType.equals("EFloatObject")||
				eType.equals("EInt")||eType.equals("EIntegerObject")||
				eType.equals("EJavaObject")||eType.equals("EJavaClass")||
				eType.equals("ELong")||eType.equals("ELongObject")||
				eType.equals("EMap")||eType.equals("EResource")||
				eType.equals("EResourceSet")||eType.equals("EShort")||
				eType.equals("EShortObject")||eType.equals("ETreeIterator");
	}

	private void createConfigCompartment(){
		NewConstructor nc = new NewConstructor();
		cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.COMPARTMENT));
		if (!cbCompartment.isSelected()) {
			gmfToolGraphMap("model",nc);	
		}else{
			gmfToolGraphMap("modelCompartment",nc);
			flagCompartmentMMSemAtribute = false;
		}
		cim.getPxGM().resetAll();
		ConfigIstarMetamodel.setFlagIndexCompartment(true);
	}

	private void gmfToolGraphMap(String type,NewConstructor nc) {
		nc.setNewCompartment(tfName.getText(), type);
		if (ConfigIstarMetamodel.isFlagIndexCompartment())
			ConfigIstarMetamodel.setIndexEspecializationCompartment(ConfigIstarMetamodel.getIndexEspecializationCompartment()+1);

		cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Actors", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
		//gmfgraph
		cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), true, null, null);
		//gmfmap
		cim.getPxGM().createInitializers(cim.getTfName().getText(), "Compartment/type", "CompartmentType::" + tfName.getText().toUpperCase());
		cim.getPxGM().createNode(cim.getTfName().getText(), "Model/actors", "Compartment", 
				"self.type=CompartmentType::" + tfName.getText().toUpperCase(), tfName.getText(), 
				"NodeObject/name", cim.getPxGT().getToolGroup("Actors"),
				ConfigIstarMetamodel.getIndexEspecializationCompartment(), tfName.getText(), true);
	}

	private void createConfigElement(){

		NewConstructor nc = new NewConstructor();

		if (cbModel.isSelected() && !cbCompartment.isSelected()) {
			cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.ELEMENT_MODEL));

			if (NewConstructor.isCreateElementModel()) {
				nc.setNewElementExist(tfName.getText(), "model");
			}else{
				nc.setNewElementIntencional(tfName.getText(), "model");
				NewConstructor.setCreateElementModel(true);
			}

			if (ConfigIstarMetamodel.isFlagIndexDependencyElements())
				ConfigIstarMetamodel.setIndexEspecializationDependencyElements(ConfigIstarMetamodel.getIndexEspecializationDependencyElements()+1);
			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Elements", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), false, null, "Model/elementsmodel");
			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "ElementModel/type", "ElementModelType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/elementsmodel", 
					"ElementModel", "self.type=ElementModelType::" + tfName.getText().toUpperCase(), 
					tfName.getText(), "NodeObject/name", cim.getPxGT().getToolGroup("Elements"),
					ConfigIstarMetamodel.getIndexEspecializationDependencyElements(), tfName.getText(), false);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexDependencyElements(true);
			flagElementModelSemAtribute= false;
		}else if (cbModel.isSelected() && cbCompartment.isSelected()) {
			cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.ELEMENT_MC));
			nc.setNewElementIntencional(tfName.getText(), "modelCompartment");

			if (ConfigIstarMetamodel.isFlagIndexDependencyElements()) {
				ConfigIstarMetamodel.setIndexEspecializationDependencyElements(ConfigIstarMetamodel.getIndexEspecializationDependencyElements()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Elements", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), false, null, "Model/elementsmm");
			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "ElementMC/type", "ElementMCType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/elementsmm", "ElementMC", 
					"self.type=ElementMCType::" + tfName.getText().toUpperCase(), tfName.getText(), 
					"NodeObject/name", cim.getPxGT().getToolGroup("Elements"), ConfigIstarMetamodel.getIndexEspecializationDependencyElements(), tfName.getText(), false);
			cim.getPxGM().resetAll();
			ConfigIstarMetamodel.setFlagIndexDependencyElements(true);
		}else if (cbCompartment.isSelected() && !cbModel.isSelected()) {
			cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.ELEMENT_COMPARTMENT));

			if (NewConstructor.isCreateElementCompartment()) {
				nc.setNewElementExist(tfName.getText(), "Compartment");
			}else{
				nc.setNewElementIntencional(tfName.getText(), "Compartment");
				NewConstructor.setCreateElementCompartment(true);
			}

			if (ConfigIstarMetamodel.isFlagIndexDependencyElements())
				ConfigIstarMetamodel.setIndexEspecializationDependencyElements(ConfigIstarMetamodel.getIndexEspecializationDependencyElements()+1);
			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Elements", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), false, null, "Compartment/elementscompartment");
			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "ElementCompartment/type", "ElementCompartmentType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Compartment/elementscompartment", "ElementCompartment", 
					"self.type=ElementCompartmentType::" + tfName.getText().toUpperCase(), 
					tfName.getText(), "NodeObject/name", cim.getPxGT().getToolGroup("Elements"), ConfigIstarMetamodel.getIndexEspecializationDependencyElements(), tfName.getText(), false);
			cim.getPxGM().resetAll();
			ConfigIstarMetamodel.setFlagIndexDependencyElements(true);
			flagElementCompartmentSemAtribute = false;
		}
	}

	private void createConfigLink(){

		String composition = "";
		if (cbModel.isSelected() && !cbCompartment.isSelected()) {
			composition = "model";
		} else if (!cbModel.isSelected() && cbCompartment.isSelected()) {
			composition = "Compartment";
		} else if (cbModel.isSelected() && cbCompartment.isSelected()) {
			composition = "modelCompartment";
		} else {
			return;
		}
		String cardinality = "";
		if (rb01.isSelected()) {
			cardinality = rb01.getName();
		} else if (rb0n.isSelected()) {
			cardinality = rb0n.getName();
		} else if (rb1n.isSelected()) {
			cardinality = rb1n.getName();
		} else {
			cardinality = rb11.getName();
		}
		NewConstructor nc = new NewConstructor();
		links.add(tfName.getText());

		nc.setNewLink(tfName.getText(), composition, cardinality);
		if (cbSourceMod.isSelected() && cbSourceEle.isSelected()) {
			nc.createSource(tfName.getText(), "source", "NodeObject", "false");
		}else if (cbSourceMod.isSelected() && !cbSourceEle.isSelected()) {
			nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
		}else if (cbSourceEle.isSelected() && !cbSourceMod.isSelected()) {
			nc.createSource(tfName.getText(), "source", "IntentionalElement", "false");
		}
		if (cbTargetMod.isSelected() && cbTargetEle.isSelected()) {
			nc.createTarget(tfName.getText(), "target", "NodeObject", "false");
		}else if (cbTargetMod.isSelected() && !cbTargetEle.isSelected()) {
			nc.createSource(tfName.getText(), "target", cbTargetMod.getText(), "false");
		}else if (cbTargetEle.isSelected() && !cbTargetMod.isSelected()) {
			nc.createTarget(tfName.getText(), "target", "IntentionalElement", "false");
		}
		if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
			ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
		}
		//gmftool
		cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
		//gmfgraph
		cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
		cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
		//gmfmap
		//Alterar os nulls
		cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")
				, null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
				cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
				tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
		cim.getPxGM().resetAll();
		ConfigIstarMetamodel.setFlagIndexRelationship(true);
	}

	private void createConfigCompartmentWithAtt(){

		NewConstructor nc = new NewConstructor();

		cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.COMPARTMENT));

		if (cbModel.isSelected() && !cbCompartment.isSelected()) {
			nc.setCompartmentAttribute(tfName.getText(), "model");
			nc.setNewCompartment(tfName.getText(), "model");

			if (ConfigIstarMetamodel.isFlagIndexCompartment()) {
				ConfigIstarMetamodel.setIndexEspecializationCompartment(ConfigIstarMetamodel.getIndexEspecializationCompartment()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Actors", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), true, null, null);

			//gmfcore
			for (int i = 0; i < attributes.size(); i++) {
				eClassifier enu = findEnum(attributes.get(i).getName());
				nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
						treatType(attributes.get(i).getType()), enu.getELiteral());
				//gmfmap
				if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
				}else{
					String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
				}

			}

			cim.getPxGM().createInitializers(cim.getTfName().getText(), "Compartment/type", "CompartmentType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/actors", tfName.getText().replaceAll(" ", ""), 
					"self.type=CompartmentType::" + tfName.getText().toUpperCase(), tfName.getText(), 
					"NodeObject/name", cim.getPxGT().getToolGroup("Actors"), ConfigIstarMetamodel.getIndexEspecializationCompartment(), tfName.getText(), true);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexCompartment(true);

		}else if (cbCompartment.isSelected() && !cbModel.isSelected()) {
			nc.setCompartmentAttribute(tfName.getText(), "Compartment");
			nc.setNewCompartment(tfName.getText(), "Compartment");

			if (ConfigIstarMetamodel.isFlagIndexCompartment()) {
				ConfigIstarMetamodel.setIndexEspecializationCompartment(ConfigIstarMetamodel.getIndexEspecializationCompartment()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Actors", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), true, null, null);
			//gmfmap
			for (int i = 0; i < attributes.size(); i++) {
				eClassifier enu = findEnum(attributes.get(i).getName());
				nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
						treatType(attributes.get(i).getType()), enu.getELiteral());

				if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
				}else{
					String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
				}

			}

			cim.getPxGM().createInitializers(cim.getTfName().getText(), "Compartment/type", "CompartmentType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/actors", tfName.getText().replaceAll(" ", ""),
					"self.type=CompartmentType::" + tfName.getText().toUpperCase(),
					tfName.getText(), "NodeObject/name", cim.getPxGT().getToolGroup("Actors"), ConfigIstarMetamodel.getIndexEspecializationCompartment(), tfName.getText(), true);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexCompartment(true);

		}else if (cbModel.isSelected() && cbCompartment.isSelected()) {
			nc.setCompartmentAttribute(tfName.getText(), "modelCompartment");
			nc.setNewCompartment(tfName.getText(), "modelCompartment");

			if (ConfigIstarMetamodel.isFlagIndexCompartment()) {
				ConfigIstarMetamodel.setIndexEspecializationCompartment(ConfigIstarMetamodel.getIndexEspecializationCompartment()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Actors", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));
			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), true, null, null);

			for (int i = 0; i < attributes.size(); i++) {
				eClassifier enu = findEnum(attributes.get(i).getName());
				nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
						treatType(attributes.get(i).getType()), enu.getELiteral());

				if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
				}else{
					String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
				}
			}
			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "Compartment/type", "CompartmentType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/actors", tfName.getText().replaceAll(" ", ""), 
					"self.type=CompartmentType::" + tfName.getText().toUpperCase(), 
					tfName.getText(), "NodeObject/name", cim.getPxGT().getToolGroup("Actors"), ConfigIstarMetamodel.getIndexEspecializationCompartment(), tfName.getText(), true);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexCompartment(true);
		}
	}

	private void createConfigElementWithAtt(){

		NewConstructor nc = new NewConstructor();

		if (cbModel.isSelected() && !cbCompartment.isSelected()) {

			cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.ELEMENT_MODEL));

			nc.setElementAttribute(tfName.getText(), "model");

			if (NewConstructor.isCreateElementModel()) {
				nc.setNewElementExist(tfName.getText(), "model");
			}else{
				nc.setNewElementIntencional(tfName.getText(), "model");
				NewConstructor.setCreateElementModel(true);
			}

			if (ConfigIstarMetamodel.isFlagIndexDependencyElements()) {
				ConfigIstarMetamodel.setIndexEspecializationDependencyElements(ConfigIstarMetamodel.getIndexEspecializationDependencyElements()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Elements", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));

			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), false, null, "Model/elementsmodel");

			for (int i = 0; i < attributes.size(); i++) {
				eClassifier enu = findEnum(attributes.get(i).getName());
				nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
						treatType(attributes.get(i).getType()), enu.getELiteral());

				if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
				}else{
					String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
				}
			}

			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "ElementModel/type", "ElementModelType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/elementsmodel", tfName.getText().replaceAll(" ", ""), 
					"self.type=ElementModelType::" + tfName.getText().toUpperCase(), tfName.getText(), 
					"NodeObject/name", cim.getPxGT().getToolGroup("Elements"), ConfigIstarMetamodel.getIndexEspecializationDependencyElements(), tfName.getText(), false);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexDependencyElements(true);

		}else if (cbCompartment.isSelected() && !cbModel.isSelected()) {

			cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.ELEMENT_COMPARTMENT));

			nc.setElementAttribute(tfName.getText(), "Compartment");
			if (NewConstructor.isCreateElementCompartment()) {
				nc.setNewElementExist(tfName.getText(), "Compartment");
			}else{
				nc.setNewElementIntencional(tfName.getText(), "Compartment");
				NewConstructor.setCreateElementCompartment(true);
			}

			if (ConfigIstarMetamodel.isFlagIndexDependencyElements()) {
				ConfigIstarMetamodel.setIndexEspecializationDependencyElements(ConfigIstarMetamodel.getIndexEspecializationDependencyElements()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Elements", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));

			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), false, null, "Compartment/elementscompartment");

			for (int i = 0; i < attributes.size(); i++) {
				eClassifier enu = findEnum(attributes.get(i).getName());
				nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
						treatType(attributes.get(i).getType()),enu.getELiteral());

				if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
				}else{
					String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
				}
			}

			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "ElementCompartment/type", "ElementCompartmentType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Compartment/elementscompartment", tfName.getText().replaceAll(" ", ""), 
					"self.type=ElementCompartmentType::" + tfName.getText().toUpperCase(), tfName.getText(), 
					"NodeObject/name", cim.getPxGT().getToolGroup("Elements"), ConfigIstarMetamodel.getIndexEspecializationDependencyElements(), tfName.getText(), false);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexDependencyElements(true);

		}else if (cbModel.isSelected() && cbCompartment.isSelected()) {

			cim.addItens(new No<String>(tfName.getText(), NODE_TYPES.ELEMENT_MC));

			nc.setElementAttribute(tfName.getText(), "modelCompartment");
			nc.setNewElementIntencional(tfName.getText(), "modelCompartment");

			if (ConfigIstarMetamodel.isFlagIndexDependencyElements()) {
				ConfigIstarMetamodel.setIndexEspecializationDependencyElements(ConfigIstarMetamodel.getIndexEspecializationDependencyElements()+1);
			}

			//gmftool
			cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Elements", cim.getPxGT().createSmallIcon("Imagem", "cin.ufpe.br.wiki.edit"));

			//gmfgraph
			cim.getPxGG().createDescriptorsNode(tfName.getText().replaceAll(" ", ""), false, null, "Model/elementsmm");

			for (int i = 0; i < attributes.size(); i++) {
				eClassifier enu = findEnum(attributes.get(i).getName());
				nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
						treatType(attributes.get(i).getType()), enu.getELiteral());

				if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
				}else{
					String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
					cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
				}
			}

			//gmfmap
			cim.getPxGM().createInitializers(cim.getTfName().getText(), "ElementMC/type", "ElementMCType::" + tfName.getText().toUpperCase());
			cim.getPxGM().createNode(cim.getTfName().getText(), "Model/elementsmm", tfName.getText().replaceAll(" ", ""), 
					"self.type=ElementMCType::" + tfName.getText().toUpperCase(), tfName.getText(), 
					"NodeObject/name", cim.getPxGT().getToolGroup("Elements"), ConfigIstarMetamodel.getIndexEspecializationDependencyElements(), tfName.getText(), false);
			cim.getPxGM().resetAll();

			ConfigIstarMetamodel.setFlagIndexDependencyElements(true);							
		}
	}

	private void createConfigLinkWithAtt(){

		NewConstructor nc = new NewConstructor();

		links.add(tfName.getText());
		if (cbModel.isSelected() && !cbCompartment.isSelected()) {
			if (rb01.isSelected()) {
				nc.setNewLink(tfName.getText(), "model", rb01.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);

			}else if (rb0n.isSelected()) {
				nc.setNewLink(tfName.getText(), "model", rb0n.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);

			}else if (rb11.isSelected()) {
				nc.setNewLink(tfName.getText(), "model", rb11.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);

			}else if (rb1n.isSelected()) {
				nc.setNewLink(tfName.getText(), "model", rb1n.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);

			}
		}else if (cbCompartment.isSelected() && !cbModel.isSelected()) {
			if (rb01.isSelected()) {
				nc.setNewLink(tfName.getText(), "Compartment", rb01.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Compartment/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}else if (rb0n.isSelected()) {
				nc.setNewLink(tfName.getText(), "Compartment", rb0n.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Compartment/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}else if (rb11.isSelected()) {
				nc.setNewLink(tfName.getText(), "Compartment", rb11.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Compartment/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}else if (rb1n.isSelected()) {
				nc.setNewLink(tfName.getText(), "Compartment", rb1n.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Compartment/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}
		}else if (cbModel.isSelected() && cbCompartment.isSelected()) {
			if (rb01.isSelected()) {
				nc.setNewLink(tfName.getText(), "modelCompartment", rb01.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}else if (rb0n.isSelected()) {
				nc.setNewLink(tfName.getText(), "modelCompartment", rb0n.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}else if (rb11.isSelected()) {
				nc.setNewLink(tfName.getText(), "modelCompartment", rb11.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}else if (rb1n.isSelected()) {
				nc.setNewLink(tfName.getText(), "modelCompartment", rb1n.getName());
				if (cbSourceMod.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceMod.getText(), "false");
				}else if (cbSourceEle.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceEle.getText(), "false");
				}else if (cbSourceLink.isSelected()) {
					nc.createSource(tfName.getText(), "source", cbSourceLink.getText(), "false");
				}
				if (cbTargetMod.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetMod.getText(), "false");
				}else if (cbTargetEle.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetEle.getText(), "false");
				}else if (cbTargetLink.isSelected()) {
					nc.createTarget(tfName.getText(), "target", cbTargetLink.getText(), "false");
				}

				if (ConfigIstarMetamodel.isFlagIndexRelationship()) {
					ConfigIstarMetamodel.setIndexEspecializationRelationship(ConfigIstarMetamodel.getIndexEspecializationRelationship()+1);
				}

				//gmftool
				cim.getPxGT().createCreationTool(tfName.getText().replaceAll(" ", ""), "Relationships", cim.getPxGT().createSmallIcon("Imagem08", "cin.ufpe.br.wiki.edit"));
				//gmfgraph
				cim.getPxGG().createDescriptorsLinkPolyline(tfName.getText().replaceAll(" ", ""));
				cim.getPxGG().createDescriptorsLinkLabel(tfName.getText().replaceAll(" ", ""));
				//gmfmap

				for (int i = 0; i < attributes.size(); i++) {
					eClassifier enu = findEnum(attributes.get(i).getName());
					nc.createAtributte(tfName.getText(), attributes.get(i).getName(), 
							treatType(attributes.get(i).getType()), enu.getELiteral());

					if (treatType(attributes.get(i).getType()).contains("ecore:EDataType")) {
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), "'" + tfName.getText().toLowerCase().replaceAll(" ", "") + "'");
					}else{
						String olc = attributes.get(i).getName().toLowerCase().replaceAll(" ", "") + "Type::" + enu.getName().toUpperCase() + enu.getELiteral().get(0).getLiteral().toUpperCase();
						cim.getPxGM().createInitializers(cim.getTfName().getText(), tfName.getText().replaceAll(" ", "") + "/" + attributes.get(i).getName(), olc);
					}
				}

				cim.getPxGM().createLinks(cim.getTfName().getText(), "Model/" + tfName.getText().toLowerCase().replaceAll(" ", ""), tfName.getText().replaceAll(" ", ""), null, tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "")+"/name",
						cim.getPxGT().getToolGroup("Relationships"), ConfigIstarMetamodel.getIndexEspecializationRelationship(), tfName.getText().replaceAll(" ", ""), tfName.getText().replaceAll(" ", "") + "/source",
						tfName.getText().replaceAll(" ", "") + "/target", false, "self <> oppositeEnd", null);
				cim.getPxGM().resetAll();

				ConfigIstarMetamodel.setFlagIndexRelationship(true);
			}
		}
	}

	/**
	 * Metodo de tratamento de eventos
	 */
	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource().equals(jbOk)) {
			if (tfName.getText().equals("")) {
				JOptionPane jp1 = new JOptionPane();
				jp1.showMessageDialog(this, "Please provide a file name!", "Warning!", JOptionPane.INFORMATION_MESSAGE);
			}else{

				Constructor cons = new Constructor();
				cons.setName(tfName.getText());

				NewConstructor nc = new NewConstructor();

				//Criao de um novo elemento de modelagem sem atributo
				if (attributes.size()==0) {
					//Compartment
					if (rbCompartment.isSelected()) {
						createConfigCompartment();
					}
					//ELEMENT
					if (rbElement.isSelected()) {
						createConfigElement();
					}
					//LINK
					if (rbLink.isSelected()) {
						createConfigLink();
					}
					//Criao de um novo elemento de modelagem com atributo
				}else{
					//Compartment
					if (rbCompartment.isSelected()) {
						createConfigCompartmentWithAtt();
					}
					//ELEMENT
					if (rbElement.isSelected()) {
						createConfigElementWithAtt();
					}
					//LINK
					if (rbLink.isSelected()) {
						createConfigLinkWithAtt();
					}
				}

				JOptionPane jp = new JOptionPane();
				int n = jp.showConfirmDialog(this, "Deseja criar um novo construtor?", "Titulo", JOptionPane.YES_NO_OPTION);

				if (n == JOptionPane.YES_OPTION) {
					this.setVisible(false);
					this.dispose();
					ConfigNewConstructor cc = new ConfigNewConstructor(cim);
					cc.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
				} else if (n == JOptionPane.NO_OPTION) {
					this.setVisible(false);
					this.dispose();
				}
				//				constructors.add(cons);
			}
			al = WindowAddLiteral.resetInstance();
		}else if (ae.getSource().equals(jbCancel)) {
			this.setVisible(false);
			this.dispose();
			al = WindowAddLiteral.resetInstance();
		}else if (ae.getSource().equals(jbAddAttri)) {
			String txt = tfAttri.getText();
			if (tfAttri.getText().equals("")) {
				JOptionPane jp = new JOptionPane();
				jp.showMessageDialog(this, "Please provide a attribute name!", "Warning!", JOptionPane.INFORMATION_MESSAGE);
			}else{

				if (rbPrimitive.isSelected()) {
					Attribute at = new Attribute(tfAttri.getText(), boxType.getSelectedItem().toString());
					if (attNames.add(at.getName())) {
						attributes.add(at);
						tfAttri.setFocusable(true);
						jbAddAttri.setFocusable(false);
						tfAttri.setFocusable(true);
						listModel.addElement(tfAttri.getText());
						tfAttri.setText("");
						tfEnum.setText("");
						rbPrimitive.setSelected(true);
						boxType.setEnabled(true);
						tfEnum.setEnabled(false);
						aux1.repaint();
						tfAttri.setFocusable(true);
					}else{
						JOptionPane jp = new JOptionPane();
						jp.showMessageDialog(this, "Atributo j existe!", "Warning!", JOptionPane.INFORMATION_MESSAGE);
					}
				}else if (rbEnum.isSelected()) {
					Attribute at = new Attribute(tfAttri.getText(), tfEnum.getText());
					if (attNames.add(at.getName())) {
						attributes.add(at);
						tfAttri.setFocusable(true);
						jbAddAttri.setFocusable(false);
						listModel.addElement(tfAttri.getText());
						tfAttri.setText("");
						tfEnum.setText("");
						rbPrimitive.setSelected(true);
						boxType.setEnabled(true);
						tfEnum.setEnabled(false);
						aux1.repaint();
						tfAttri.setFocusable(true);
						eClassifier enu = new eClassifier();
						enu.setName(at.getName());
						enums.add(enu);
						al = WindowAddLiteral.getInstance(enu);
					}else{
						JOptionPane jp = new JOptionPane();
						jp.showMessageDialog(this, "Atributo j existe!", "Warning!", JOptionPane.INFORMATION_MESSAGE);
					}
				}
			}
		}else if (ae.getSource().equals(jbRemAttri)) {
			for (int i = jlAttri.getSelectedIndices().length; i > 0; i--) {
				for (Iterator iterator = attNames.iterator(); iterator.hasNext();) {
					String string = (String) iterator.next();
					if (string.equals(jlAttri.getSelectedValues()[i-1]))
						for (int j = 0; j < attributes.size(); j++)
							if (attributes.get(j).getName().equals(string)) {
								attributes.remove(j);
								iterator.remove();
								removeEnum(attributes.get(j).getName());
							}
				}
				listModel.remove(jlAttri.getSelectedIndices()[i-1]);
			}
		}else if (ae.getSource().equals(rbCompartment)) {
			lbCard.setEnabled(false);
			rb01.setEnabled(false);
			rb0n.setEnabled(false);
			rb11.setEnabled(false);
			rb1n.setEnabled(false);
			cbSourceMod.setEnabled(false);
			cbSourceEle.setEnabled(false);
			cbSourceLink.setEnabled(false);
			cbTargetMod.setEnabled(false);
			cbTargetEle.setEnabled(false);
			cbTargetLink.setEnabled(false);
			jbConstraint.setEnabled(false);
			rbIntentionalElementYes.setEnabled(false);
			rbIntentionalElementNo.setEnabled(false);
		}else if (ae.getSource().equals(rbElement)) {
			lbCard.setEnabled(false);
			rb01.setEnabled(false);
			rb0n.setEnabled(false);
			rb11.setEnabled(false);
			rb1n.setEnabled(false);
			cbSourceMod.setEnabled(false);
			cbSourceEle.setEnabled(false);
			cbSourceLink.setEnabled(false);
			cbTargetMod.setEnabled(false);
			cbTargetEle.setEnabled(false);
			cbTargetLink.setEnabled(false);
			jbConstraint.setEnabled(false);
			rbIntentionalElementYes.setEnabled(true);
			rbIntentionalElementNo.setEnabled(true);
		}else if (ae.getSource().equals(rbLink)) {
			lbCard.setEnabled(true);
			rb01.setEnabled(true);
			rb0n.setEnabled(true);
			rb11.setEnabled(true);
			rb1n.setEnabled(true);
			cbSourceMod.setEnabled(true);
			cbSourceEle.setEnabled(true);
			cbSourceLink.setEnabled(true);
			cbTargetMod.setEnabled(true);
			cbTargetEle.setEnabled(true);
			cbTargetLink.setEnabled(true);
			jbConstraint.setEnabled(true);
			rbIntentionalElementYes.setEnabled(false);
			rbIntentionalElementNo.setEnabled(false);
		}else if (ae.getSource().equals(rbPrimitive)) {
			boxType.setEnabled(true);
			tfEnum.setEnabled(false);
			aux1.repaint();
		}else if (ae.getSource().equals(rbEnum)) {
			tfEnum.setEnabled(true);
			boxType.setEnabled(false);
			aux1.repaint();
		}else if (ae.getSource().equals(jbConstraint)) {
			ArrayList<No<String>> source = new ArrayList<No<String>>(),target = new ArrayList<No<String>>();
			for(No n: cim.getNodes()){
				if((n.n == NODE_TYPES.COMPARTMENT &&cbSourceMod.isSelected())||(n.n == NODE_TYPES.ELEMENT_MC && cbSourceEle.isSelected())||(n.n == NODE_TYPES.ELEMENT_MODEL && cbSourceLink.isSelected()))
					source.add(n);
				if((n.n == NODE_TYPES.COMPARTMENT &&cbTargetMod.isSelected())||(n.n == NODE_TYPES.ELEMENT_MC && cbTargetEle.isSelected())||(n.n == NODE_TYPES.ELEMENT_MODEL && cbTargetLink.isSelected()))
					target.add(n);
			}
			newLink = new Constraints<String>(tfName.getText(), source, target, cim.getRelacoesNewLink(), cim);
		}
	}

	private eClassifier findEnum(String name){

		for (int i = 0; i < enums.size(); i++) {
			if(enums.get(i).getName().equals(name))
				return enums.get(i);
		}
		return new eClassifier();
	}

	private void removeEnum(String name){

		for (int i = 0; i < enums.size(); i++) {
			if(enums.get(i).getName().equals(name))
				enums.remove(i);
		}
	}

	public static ArrayList<String> getLinks() {
		return links;
	}

	public static void setLinks(ArrayList<String> links) {
		ConfigNewConstructor.links = links;
	}

}
