package istar_pl.actions;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.text.BadLocationException;
import javax.swing.text.Highlighter;
import javax.swing.text.JTextComponent;

public class Constraints<E> extends JFrame{

	private JTextArea source_Constraints,target_Constraints,constraints;

	private ButtonGroup sourceGroup;
	private JButton Add,Del,Ok,Close;
	private JList regrasList;
	private JScrollPane scrollPane,scrollPaneSC, scrollPaneTC, scrollPaneC;
	private ArrayList<No<E>> elementsSource,elementsTarget;
	private ArrayList<JRadioButton> source;
	private ArrayList<JCheckBox> target;
	private ArrayList<Relacoes<No>> relactions;
	private String allSource;
	private String allTargets;
	private String strConstraint;
	private String relationship;
	
	private ConfigIstarMetamodel cim;
	/**
	 * Esta classe  uma janela que retorna todas as relaes e constraints.
	 * @param relationship
	 * @param elementsSource
	 * @param relactions
	 */
	public Constraints(String relationship, ArrayList<No<E>> elementsSource, ArrayList<No<E>> elementsTarget,ArrayList<Relacoes<No>> relactions, ConfigIstarMetamodel cim) {

		super(relationship + " Constraints");
		this.relactions = relactions;
		this.cim=cim;
		this.relationship=relationship;
		this.source = new ArrayList<JRadioButton>();
		this.target = new ArrayList<JCheckBox>();
		
		if(elementsSource == null)
			elementsSource = new ArrayList<No<E>>();
		if(elementsTarget == null)
			elementsTarget = new ArrayList<No<E>>();
		
		this.elementsSource = elementsSource;
		this.elementsTarget = elementsTarget;
		
		this.setSize(900, 700);
		initComponents();
		regrasList.setListData(this.relactions.toArray());
		setLocationRelativeTo(null);
		setVisible(true);

		boolean flagSource = true;
		boolean flagTarget = true;
		allSource = new String();
		allTargets = new String();
		oclGen(flagSource, flagTarget);
		preencherCampos();
		Actions();
		preencherCampos();
	}

	/**
	 * Gera os ocls de List.
	 * @param flagSource
	 * @param flagTarget
	 */
	private void oclGen(boolean flagSource, boolean flagTarget) {
		for (No n : getSources()) {
			if (flagSource) {
				allSource=getOCL(n);
				flagSource = false;
			}else{
				allSource += " or " + getOCL(n);
			}
		}
		for (No n : getTargets()) {
			if (flagTarget) {
				allTargets = getOCL(n);
				flagTarget = false;
			}else{
				allTargets += " or " + getOCL(n);
			}
		}
	}

	/**
	 * Cria os listnes
	 */
	private void Actions() {
		actionAdd();
		actionDel();
		actionOk();
	}

	/**
	 * Cria o listen Ok
	 */
	private void actionOk() {
		this.Ok.addActionListener(new ActionListnerTela<No<E>>(this.elementsSource,this.relactions) {
			public void actionPerformed(ActionEvent e) {
				boolean flagSource = true;
				boolean flagTarget = true;
				allSource = new String();
				allTargets = new String();
				oclGen(flagSource, flagTarget);
				preencherCampos();
				
				if (relationship.equals("Contribution Link")) {
					cim.setStrContriSource(allSource);
					cim.setStrContriTarget(allTargets);
					cim.setStrContriConstraint(getOclConstraint());
				}else if (relationship.equals("MeansEndLink")) {
					cim.setStrMeansSource(allSource);
					cim.setStrMeansTarget(allTargets);
					cim.setStrMeansConstraint(getOclConstraint());
				}else if (relationship.equals("TaskDecomposition")) {
					cim.setStrDecomSource(allSource);
					cim.setStrDecomTarget(allTargets);
					cim.setStrDecomConstraint(getOclConstraint());
				}else if (relationship.equals("Dependency Link")) {
					cim.setStrDepenSource(allSource);
					cim.setStrDepenTarget(allTargets);
					cim.setStrDepenConstraint(getOclConstraint());
				}
				setVisible(false);
			}
		});
	}

	/**
	 * Cria o listen Del
	 */
	private void actionDel() {
		this.Del.addActionListener(new ActionListnerTela<No<E>>(this.elementsSource,this.relactions) {
			public void actionPerformed(ActionEvent e) {
				for(int i = regrasList.getSelectedIndices().length-1;i>=0;i--){
					pilha.remove(regrasList.getSelectedIndices()[i]);
				}
				String[] s = new String[pilha.size()];
				for(Relacoes<No> x: pilha){
					s[pilha.indexOf(x)] = x.toString();
				}
				regrasList.setListData(s);
				boolean flagSource = true;
				boolean flagTarget = true;
				allSource = new String();
				allTargets = new String();
				oclGen(flagSource, flagTarget);
				preencherCampos();
			}
		});
	}

	/**
	 * Cria o listen Add
	 */
	private void actionAdd() {
		this.Add.addActionListener(new ActionListnerTela<No<E>>(this.elementsSource,this.relactions) {
			public void actionPerformed(ActionEvent e) {
				int selectedSource = 0, selectedTarget = 0;
				for(JRadioButton j:source){
					if(j.isSelected()){
						break;
					}
					selectedSource++;
				}
				for(JCheckBox j:target){
					if(j.isSelected()){
						boolean contem = false;
						Relacoes<No> relacao = new Relacoes<No>(itens.get(selectedSource), itens.get(selectedTarget));
						for(Relacoes<No> x: pilha){
							contem = contem || x.equals(relacao);
						}
						if(!contem)
							pilha.add(relacao);
					}
					selectedTarget++;
				}
				String[] s = new String[pilha.size()];
				for(Relacoes<No> x: pilha){
					s[pilha.indexOf(x)] = x.toString();
				}
				regrasList.setListData(s);
				boolean flagSource = true;
				boolean flagTarget = true;
				allSource = new String();
				allTargets = new String();
				oclGen(flagSource, flagTarget);
				preencherCampos();
			}
			
		});
	}

	//#region ComponenteGrfico
	/**
	 * Inicializa os componenters grficos.
	 */
	private void initComponents() {

		allSource = new String();
		allTargets = new String();

		this.Add = new JButton("Add");
		this.Close = new JButton("Close");
		this.Del = new JButton("Del");
		this.Ok = new JButton("Ok");

		this.sourceGroup = new ButtonGroup();
		this.regrasList = new JList();

		JPanel p1 = new JPanel();
		p1.setLayout(new BorderLayout());
		p1.add(getJPanelButtonOut(), BorderLayout.SOUTH);
		p1.add(getJPanelDown(), BorderLayout.CENTER);
		p1.add(getJPanelUtil(), BorderLayout.NORTH);
		this.add(p1);
	}

	private JPanel getJPanelButtonOut() {
		JPanel p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.RIGHT));
		p.add(new Label(" "));
		p.add(this.Ok);
		p.add(new Label(" "));
		p.add(this.Close);
		p.add(new Label(" "));
		return p;
	}

	private JPanel getJPanelUtil() {
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
		p.add(new Label(""));
		p.add(getJPanelSource());
		p.add(new Label(""));
		p.add(getJPanelTarget());
		p.add(new Label(""));
		p.add(getJPanelAddDel());
		p.add(new Label(""));
		p.add(getJPanelRegras());
		p.add(new Label(""));
		return p;
	}

	private JPanel getJPanelSource(){
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
		p.setBorder(BorderFactory.createTitledBorder("Source"));
		for(No<E> e:elementsSource){
			JRadioButton j = new JRadioButton(e.toString());
			j.addActionListener(new CleanCheks());
			source.add(j);
			sourceGroup.add(source.get(source.size()-1));
			p.add(source.get(source.size()-1));
		}
		return p;
	}

	private JPanel getJPanelDown(){
		JPanel p = new JPanel();
		source_Constraints = new JTextArea();
		source_Constraints.setLineWrap(true);
		scrollPaneSC = new JScrollPane(source_Constraints);
		scrollPaneSC.setPreferredSize(new Dimension(30, 60));

		target_Constraints = new JTextArea();
		target_Constraints.setLineWrap(true);
		scrollPaneTC = new JScrollPane(target_Constraints);
		scrollPaneTC.setPreferredSize(new Dimension(30, 60));

		constraints = new JTextArea();
		constraints.setLineWrap(true);
		scrollPaneC = new JScrollPane(constraints);
		scrollPaneC.setPreferredSize(new Dimension(30, 230));

		p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
		p.add(new Label("Source Constraints"));
		p.add(scrollPaneSC);
		p.add(new Label("Target Constraints"));
		p.add(scrollPaneTC);
		p.add(new Label("Constraints"));
		p.add(scrollPaneC);
		return p;
	}

	private JPanel getJPanelTarget(){
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
		p.setBorder(BorderFactory.createTitledBorder("Target"));
		for(No<E> e:elementsTarget){
			target.add(new JCheckBox(e.toString()));
			p.add(target.get(target.size()-1));
		}
		return p;
	}

	private JPanel getJPanelAddDel(){
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.Y_AXIS));
		p.add(new Label(""));
		p.add(this.Add);
		p.add(new Label(""));
		p.add(this.Del);
		p.add(new Label(""));
		return p;
	}

	private JPanel getJPanelRegras(){
		JPanel p = new JPanel();
		p.setLayout(new BorderLayout());
		regrasList =  new JList();
		regrasList.setVisibleRowCount(elementsSource.size());

		scrollPane = new JScrollPane(regrasList);

		p.add(new Label(""),BorderLayout.NORTH);
		p.add(new Label(""),BorderLayout.SOUTH);
		p.add(scrollPane, BorderLayout.CENTER);
		return p;
	}
	
	//#endregion ComponenteGrfico

	/**
	 * Retorna  todos os targests sem repetio
	 */
	public ArrayList<No> getTargets(No source){
		ArrayList<No> retorno = new ArrayList<No>();
		for(Relacoes r: relactions)
			if(r.getSource() == source)
				retorno.add((No) r.getTarget());
		return retorno;
	}

	/**
	 * Retorna as regras em OCL
	 * @return String
	 */
	public String getOclConstraint(){
		String retorno = "";
		int i = 0;
		if(getSources().size()<=1)
			return retorno;
		for(No source : getSources()){
			if(source == getSources().get(getSources().size()-1)){
				for(No target : getTargets(source)){
					retorno += getNivel(i)+"self.target.oclAsType("+getOCL2(target)+").type="+getOCL3(target)+" or ";
				}
				retorno = retorno.substring(0, retorno.length() - 4) + "\n";
				i--;
				continue;
			}
			retorno += getNivel(i)+"if self.source.oclAsType("+getOCL2(source)+").type="+getOCL3(source)+" then\n\t"+getNivel(i);
			for(No target : getTargets(source)){
				retorno += "self.target.oclAsType("+getOCL2(target)+").type="+getOCL3(target)+" or ";
			}
			retorno = retorno.substring(0, retorno.length() - 4) + "\n"+getNivel(i)+"else\n";
			i++;
		}
		for(int j = 0; j<getSources().size()-1;j++){
			retorno += getNivel(i)+"endif\n";
			i--;
		}
		return retorno;

	}

	/**
	 * identa o texto
	 * @param i
	 * @return
	 */
	public String getNivel(int i){
		String retorno = "";
		for(;i>0;i--)
			retorno += '\t';
		return retorno;
	}

	/**
	 * Preenche os campos
	 */
	public void preencherCampos(){
		source_Constraints.setText(allSource.toString());
		target_Constraints.setText(allTargets.toString());
		constraints.setText(getOclConstraint().toString());
		constraints.setHighlighter(null);
	}

	/**
	 * retorna a lista de sources sem ter repeties
	 * @return
	 */
	public ArrayList<No<E>> getSources(){
		ArrayList<No<E>> sources = new ArrayList<No<E>>();
		boolean existe;
		for(Relacoes<No> r: relactions){
			existe = false;
			for(No<E> e:sources)
				existe = existe || e.toString().equals(r.getSource().toString());
			if(!existe)
				sources.add(r.getSource());
		}
		return sources;
	}

	/**
	 * retorna a lista de targets sem ter repeties
	 * @return
	 */
	public ArrayList<No<E>> getTargets(){
		ArrayList<No<E>> targets = new ArrayList<No<E>>();
		boolean existe;
		for(Relacoes<No> r: relactions){
			existe = false;
			for(No<E> e:targets)
				existe = existe || e.toString().equals(r.getTarget().toString());
			if(!existe)
				targets.add(r.getTarget());
		}
		return targets;
	}

	public String getOCL(No<E> e){
		switch(e.n){
		case ELEMENT_MC:
			return "self.oclAsType(ElementMC).type=ElementMCType::"+e.toString().toUpperCase();
		case ELEMENT_MODEL:
			return "self.oclAsType(ElementModel).type=ElementModelType::"+e.toString().toUpperCase();
		case ELEMENT_COMPARTMENT:
			return "self.oclAsType(ElementCompartment).type=ElementCompartmentType::"+e.toString().toUpperCase();
		default:
			return "self.oclAsType(Compartment).type=CompartmentType::"+e.toString().toUpperCase();
		}
	}
	
	public String getOCL2(No<E> e){
		switch(e.n){
		case ELEMENT_MC:
			return "ElementMC";
		case ELEMENT_MODEL:
			return "ElementModel";
		case ELEMENT_COMPARTMENT:
			return "ElementCompartment";
		default:
			return "Compartment";
		}
	}
	
	public String getOCL3(No<E> e){
		switch(e.n){
		case ELEMENT_MC:
			return "ElementMCType::"+e.toString().toUpperCase();
		case ELEMENT_MODEL:
			return "ElementModelType::"+e.toString().toUpperCase();
		case ELEMENT_COMPARTMENT:
			return "ElementCompartmentType::"+e.toString().toUpperCase();
		default:
			return "CompartmentType::"+e.toString().toUpperCase();
		}
	}
	
	private abstract class ActionListnerTela<E> implements ActionListener{

		public ArrayList<E> itens;
		public ArrayList<Relacoes<No>> pilha;
		public ActionListnerTela(ArrayList<E> itens, ArrayList<Relacoes<No>> pilha) {
			this.itens = itens;
			this.pilha = pilha;
		}
	}

	private class CleanCheks implements ActionListener {
		@Override
		public void actionPerformed(ActionEvent e) {
			for(JCheckBox j : target){
				j.setSelected(false);
			}
		}
	}

	public String getAllSource() {
		return allSource;
	}

	public void setAllSource(String allSource) {
		this.allSource = allSource;
	}

	public String getAllTargets() {
		return allTargets;
	}

	public void setAllTargets(String allTargets) {
		this.allTargets = allTargets;
	}

	public String getStrConstraint() {
		return strConstraint;
	}

	public void setStrConstraint(String strConstraint) {
		this.strConstraint = strConstraint;
	}

	public JTextArea getSource_Constraints() {
		return source_Constraints;
	}

	public void setSource_Constraints(JTextArea sourceConstraints) {
		source_Constraints = sourceConstraints;
	}

	public JTextArea getTarget_Constraints() {
		return target_Constraints;
	}

	public void setTarget_Constraints(JTextArea targetConstraints) {
		target_Constraints = targetConstraints;
	}

	public JTextArea getConstraints() {
		return constraints;
	}

	public void setConstraints(JTextArea constraints) {
		this.constraints = constraints;
	}
	
	public class OCLHighLighter implements Highlighter{

		@Override
		public Object addHighlight(int p0, int p1, HighlightPainter p)
				throws BadLocationException {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public void changeHighlight(Object tag, int p0, int p1)
				throws BadLocationException {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void deinstall(JTextComponent c) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public Highlight[] getHighlights() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public void install(JTextComponent c) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void paint(Graphics g) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void removeAllHighlights() {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void removeHighlight(Object tag) {
			// TODO Auto-generated method stub
			
		}
		
	}
	
}
