package istar_pl.actions;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.UIManager;

import Injection.ParserXML_Metamodel;

public class MainWindow extends JFrame implements ActionListener{

	private static MainWindow instance = null;
	public static String tipoModelo = "Create SD Model";     
	
	private String path;
	
	private Container tela;
	private JRadioButton rbSD, rbSR;
	private JPanel pradios, plabels, paux, pname, pbuttons;
	private JLabel lbInfo, lbInfoName;
	private JTextField tfName;
	private JButton jbCreateFile, jbCancel;
	private File f;
	
	private JFileChooser fc;
	
	public MainWindow(){
		super("Create a new metamodel");
		
        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null,
                    "No foi possvel carregar o \"Skin\" padro. Definindo o padro original.", "Erro",
                    JOptionPane.ERROR_MESSAGE);
        }
		
		tela = getContentPane();
		tela.setLayout(new BorderLayout());
		
		createJLabel();
		createJTextField();
		createJButtons();
		createJRadiobutton();
		createJPanels();
		
		tela.add(BorderLayout.NORTH, pname);
		tela.add(BorderLayout.SOUTH, pbuttons);
		
		fc = new JFileChooser();
		
		setSize(330, 200);
		setVisible(true);
		setResizable(false);
		setLocationRelativeTo(null);
	}
	
	public void createJButtons(){
		jbCreateFile = new JButton("Create");
		jbCreateFile.addActionListener(this);
		jbCancel = new JButton("Cancel");
		jbCancel.addActionListener(this);
	}
	
	public void createJLabel(){
		lbInfo = new JLabel("Create a new metamodel:");
		lbInfoName = new JLabel("File Name:");
	}
	
	public void createJTextField(){
		tfName = new JTextField();
		tfName.setPreferredSize(new Dimension(185,20));
	}
	
	public void createJRadiobutton(){
		rbSD = new JRadioButton("Create SD Model");
		rbSD.setSelected(true);
		rbSR = new JRadioButton("Create SR Model");
		
		ButtonGroup group = new ButtonGroup();
		group.add(rbSD);
		group.add(rbSR);
	}
	public void createJPanels(){
		
		pname = new JPanel(new FlowLayout(FlowLayout.LEFT));
		pname.add(lbInfoName);
		pname.add(tfName);
		pname.add(jbCreateFile);
		
		pbuttons = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		pbuttons.add(jbCancel);
	}
	
	public void exit(){
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	}

//	@Override
	public void actionPerformed(ActionEvent e) {
			if (e.getSource().equals(jbCreateFile)) {
			
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int returnVal = fc.showOpenDialog(MainWindow.this);
			
			if (returnVal == JFileChooser.APPROVE_OPTION) {
			 f = fc.getSelectedFile();
			}
			 
			ParserXML_Metamodel px = new ParserXML_Metamodel();
			px.createAlias();
			px.createCore();
			px.createXML();
			px.createFile(f.getPath(), tfName.getText());
			 
			setVisible(false);
		}else if (e.getSource().equals(jbCancel)) {
			setVisible(false);
			exit();
		}
		
	}
	
	public static void main(String[] args) {
		MainWindow n = new MainWindow();
		n.exit();
	}
}
