package istar_pl.actions;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.UIManager;

import beans.metamodel.eClassifier;
import beans.metamodel.eLiteral;

public class WindowAddLiteral extends JFrame implements ActionListener{

	private static WindowAddLiteral instance = null;
	
	//private ArrayList<String> literalsEnum;
	private eClassifier enu;
	
	private Container tela;
	private DefaultListModel listModel;
	private JList jlAttri;
	private JScrollPane listScroller;
	private JLabel lbName;
	private JTextField tfName;
	private JPanel jpCenter, jpSouth;
	private JButton jbAddAttri;
	private JButton jbRemAttri;

	private JButton jbOk;

	private JButton jbCancel;
	
	private WindowAddLiteral(eClassifier enu){
		super("Add Literals");
		
        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null,
                    "No foi possvel carregar o \"Skin\" padro. Definindo o padro original.", "Erro",
                    JOptionPane.ERROR_MESSAGE);
        }
		
		tela = getContentPane();
		tela.setLayout(new BorderLayout());
		
		createJLabel();
		createJButton();
		createJList();
		createJPanel();
		
		setSize(310,165);
		setVisible(true);
		setResizable(false);
		setLocationRelativeTo(null);
		
		tela.add(BorderLayout.CENTER, jpCenter);
		tela.add(BorderLayout.EAST, listScroller);
		tela.add(BorderLayout.SOUTH, jpSouth);
		
//		literalsEnum = new ArrayList<String>();
		this.enu = enu;
		
	}
	
	public static WindowAddLiteral getInstance(eClassifier enu){

		return instance = new WindowAddLiteral(enu);
	}
	
	public static WindowAddLiteral resetInstance(){
		return instance = null;
	}
	
	public void createJLabel(){
		lbName = new JLabel("Literal name:");
		
		tfName = new JTextField();
		tfName.setPreferredSize(new Dimension(115,20));
	}
	
	public void createJButton(){
		
		jbOk = new JButton("Ok");
		jbOk.addActionListener(this);
		
		jbCancel = new JButton("Cancel");
		jbCancel.addActionListener(this);
		
		jbAddAttri = new JButton("Add");
		jbAddAttri.addActionListener(this);
		
		jbRemAttri = new JButton("Del");
		jbRemAttri.addActionListener(this);
	}
	
	public void createJList(){
		listModel = new DefaultListModel();
		
		jlAttri = new JList(listModel);
		jlAttri.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		jlAttri.setLayoutOrientation(JList.VERTICAL);
		jlAttri.setVisibleRowCount(-1);
		jlAttri.setPreferredSize(new Dimension(110,100));
		
		listScroller = new JScrollPane(jlAttri, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		listScroller.setPreferredSize(new Dimension(110,100));
	}
	
	public void createJPanel(){
		
		JPanel aux01 = new JPanel(new FlowLayout(FlowLayout.LEFT));
		aux01.add(lbName);
		aux01.add(tfName);
		
		JPanel aux02 = new JPanel(new FlowLayout(FlowLayout.CENTER));
		aux02.add(jbAddAttri);
		aux02.add(jbRemAttri);
		
		jpCenter = new JPanel(new BorderLayout());
		jpCenter.add(BorderLayout.NORTH, aux01);
		jpCenter.add(BorderLayout.CENTER, aux02);
		
		jpSouth = new JPanel(new FlowLayout(FlowLayout.RIGHT));
		jpSouth.add(jbOk);
		jpSouth.add(jbCancel);
	}
	
	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource().equals(jbAddAttri)) {
			if (tfName.getText().equals("")) {
				JOptionPane jp = new JOptionPane();
				jp.showMessageDialog(this, "Digite o nome!", "Warning!", JOptionPane.INFORMATION_MESSAGE);
			}else{
				listModel.addElement(tfName.getText());
				eLiteral temp = new eLiteral();
				temp.setLiteral(tfName.getText());
				enu.getELiteral().add(temp);
				//literalsEnum.add(tfName.getText());
				tfName.setText("");
				tfName.setFocusable(true);
				jbAddAttri.setFocusable(false);
				jbRemAttri.setFocusable(false);
				jlAttri.setFocusable(false);
			}
		}else if (ae.getSource().equals(jbRemAttri)) {
			for (int i = jlAttri.getSelectedIndices().length; i > 0; i--) {
				for (int j = 0; j < enu.getELiteral().size(); j++) {
					String string = enu.getELiteral().get(j).getLiteral();
					if (string.equals(jlAttri.getSelectedValues()[i-1])) {
						enu.getELiteral().remove(j);
				    }
				}
				listModel.remove(jlAttri.getSelectedIndices()[i-1]);
			}
		}else if (ae.getSource().equals(jbOk)) {
			this.setVisible(false);
			this.dispose();
		}else if (ae.getSource().equals(jbCancel)) {
			this.setVisible(false);
			this.dispose();
		}
	}
	
//	public ArrayList<String> getLiteralsEnum() {
//		return literalsEnum;
//	}
//
//	public void setLiteralsEnum(ArrayList<String> literalsEnum) {
//		this.literalsEnum = literalsEnum;
//	}

//	public static void main(String[] args) {
//		WindowAddLiteral al = new WindowAddLiteral();
//		al.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
//	}

}
